-- グルーヴレーダーの値を設定（Player player, string radarCategory） :int
local function RadarValue(player, radarCategory)
	local values = W_PLAYER:Radar(player)
	return values[radarCategory]
end
-- 判定ラベルの値を設定
local function Judgment()
	return W_OPTION:ReadPref('JudgmentMode')
end
local detailMode = false

YA_SHARE:Functions({
	RadarValue = RadarValue,
	Judgment   = Judgment,
})

-- ポップアップしたスクリーンに情報を渡せるようにsetenvする
local shareUrl = {}
for k,pn in pairs({PLAYER_1, PLAYER_2}) do
	if GAMESTATE:IsPlayerEnabled(pn) then
		shareUrl[pn] = YA_SHARE:Url(pn)
	end
end
setenv('WAIEI_ShareUrl', shareUrl)
setenv('WAIEI_PlayedSong', {})

return Def.ActorFrame({
    OnCommand = function(self)
        SCREENMAN:GetTopScreen():lockinput(0.5)
        setenv('WAIEI_ScreenTimer', SCREENMAN:GetTopScreen():GetChild('Timer'))
		-- リザルト突入時のBPMが異常に高いとフリーズを起こすのでSetCurrentSongをnilにする
		local song = GAMESTATE:GetCurrentSong()
		setenv('WAIEI_PlayedSong', {
			Song = song or nil,
			Steps = {
				PLAYER_1 = GAMESTATE:GetCurrentSteps(PLAYER_1) or nil,
				PLAYER_2 = GAMESTATE:GetCurrentSteps(PLAYER_2) or nil,
			}
		})
		if song then
			GAMESTATE:SetCurrentSong(nil)
		end
    end,
	-- キー操作
	Def.Actor({
		CodeMessageCommand = function(self, params)
			if not W_PLAYER:IsEnabled(params.PlayerNumber) then
				return
			end
			local CallToggleDetailMessage = function(params)
				detailMode = not detailMode
				if detailMode then
					MESSAGEMAN:Broadcast('ShowDetail', {
						Player = params.PlayerNumber
					})
				else
					MESSAGEMAN:Broadcast('HideDetail', {
						Player = params.PlayerNumber
					})
				end
			end
			if params.Name == 'Left' then
				CallToggleDetailMessage(params)
			elseif params.Name == 'Right' then
				CallToggleDetailMessage(params)
			end
			if params.Name == 'Share' then
				SCREENMAN:AddNewScreenToTop('ScreenEvaluationQRCode')
			end
		end,
	}),
})