local shareUrl = getenv('WAIEI_ShareUrl')

local function QRActor()
    local actor = Def.ActorFrame({})
    for k,pn in pairs({PLAYER_1, PLAYER_2}) do
        if GAMESTATE:IsPlayerEnabled(pn) then
            local text = shareUrl[pn].Error or shareUrl[pn].Url..'?'..shareUrl[pn].Query
            YA_QRCODE:Color(Color('White'), BoostColor(W_PLAYER:Color(pn), 0.75))
            actor[#actor+1] = Def.ActorFrame({
                OnCommand = function(self)
                    local add = 220 + math.min((SCREEN_WIDTH-640)/4, 60)
                    self:x(add * (W:IsP1(pn) and -1 or 1))
                end,
                YA_QRCODE:Actor(text, 140, 0)..{
                    OnCommand = function(self)
                        self:y(-10)
                    end,
                },
                LoadFont('Common Normal')..{
                    Text = W_PLAYER:Name(pn),
                    OnCommand = function(self)
                        self:y(80)
                        self:zoom(0.66)
                        self:maxwidth(140/0.66)
                    end,
                },
            })
        end
    end
    return actor
end

local function hasError(data)
    if (data[PLAYER_1] and data[PLAYER_1].Error) then
        return data[PLAYER_1].Error
    end
    if (data[PLAYER_2] and data[PLAYER_2].Error) then
        return data[PLAYER_2].Error
    end
    return nil
end
local centerText = THEME:GetString('ScreenEvaluation', 'ShareMainHelperText')
                    ..((W_OPTION:ReadPref('ExecBrowser') and not hasError(shareUrl))
                        and '\n\n'..THEME:GetString('ScreenEvaluation', 'ShareBrowserHelperText')
                        or (hasError(shareUrl) and '\n\n'..hasError(shareUrl) or ''))

return Def.ActorFrame({
    Def.ActorFrame({
        Def.Quad({
            OnCommand = function(self)
                self:Center()
                self:diffuse(0, 0, 0, 0)
                self:fadetop(0.25)
                self:fadebottom(0.25)
                self:zoomto(SCREEN_WIDTH, SCREEN_HEIGHT-80)
                self:linear(0.2)
                self:diffusealpha(0.5)
            end,
            OffMessageCommand = function(self)
                self:linear(0.2)
                self:diffusealpha(0)
            end,
        }),
        Def.ActorFrame({
            OnCommand = function(self)
                self:Center()
                self:addy(-65)
                self:zoomx(0)
                self:linear(0.2)
                self:zoomx(1)
            end,
            OffMessageCommand = function(self)
                self:linear(0.2)
                self:zoomx(0)
            end,
            LoadActor(W:Object('boxshadow'), 'Overlay', {
                Length = 20,
                --Color  = {0, 1, 1, 0.4},
                Color  = {0, 0, 0, 0.66},
                Center = {0, 0.1, 0.2, 0.5},
            })..{
                OnCommand = function(self, params)
                    self:playcommand('UpdateBoxShadow', {
                        Id         = 'Overlay',
                        Width      = SCREEN_WIDTH,
                        Height     = 200,
                    })
                end,
            },
            Def.Quad({
                OnCommand = function(self)
                    self:diffuse(1, 1, 1, 1)
                    self:fadeleft(1)
                    self:faderight(1)
                    self:zoomto(SCREEN_WIDTH, 1)
                    self:y(-100)
                end,
            }),
            Def.Quad({
                OnCommand = function(self)
                    self:diffuse(1, 1, 1, 1)
                    self:fadeleft(1)
                    self:faderight(1)
                    self:zoomto(SCREEN_WIDTH, 1)
                    self:y(100)
                end,
            }),
            QRActor(),
            LoadFont('Common Small Normal')..{
                Text = centerText,
                OnCommand = function(self)
                    self:y(-10)
                    self:zoom(0.5)
                    self:wrapwidthpixels(260/0.5)
                    self:vertspacing(10)
                end,
            },
            LoadFont('Common Small Normal')..{
                Text = THEME:GetString('ScreenEvaluation', 'ShareHelperText'),
                OnCommand = function(self)
                    self:y(80)
                    self:zoom(0.5)
                end,
            },
        }),
    }),
})