local screen
local openableBrowser = W_OPTION:ReadPref('ExecBrowser')
local shareUrl = getenv('WAIEI_ShareUrl')

local function Input(params)
	local function OverlayCancel(...)
		local wait = ...
		screen:lockinput(0.25)
		screen:RemoveInputCallback(Input)
		MESSAGEMAN:Broadcast('Off', {Wait = wait or nil})
	end
	if not screen 
		or params.type ~= 'InputEventType_FirstPress'
		or not params.PlayerNumber then return end
	if W_PLAYER:IsEnabled(params.PlayerNumber)
		and (params.button == 'Back'
				or params.button == 'Start'
				or params.button == 'Down') then
		OverlayCancel(0.2)
	end
	if openableBrowser and params.button == 'Up' then
        local pn = params.PlayerNumber
        if shareUrl[pn] and not shareUrl[pn].Error then
            YA_SHARE:Send(shareUrl[pn].Query)
    		OverlayCancel(0.2)
        end
	end
end

-- タイマーが0になった場合強制的に閉じる
local timerChild = getenv('WAIEI_ScreenTimer')
local function update(self, delta)
	if timerChild then
		if tonumber(timerChild:GetSeconds()) <= 0 then
			timerChild:SetSeconds(0.01)
			timerChild:start()
			screen:lockinput(0.25)
			screen:RemoveInputCallback(Input)
			MESSAGEMAN:Broadcast('Off', {Wait = 0})
		end
	end
end

-- キー操作
return Def.ActorFrame({
	Def.ActorFrame({
		OnCommand = function(self)
			screen = SCREENMAN:GetTopScreen()
			screen:AddInputCallback(Input)
			self:SetUpdateFunction(update)
			MESSAGEMAN:Broadcast('ShowBlur')
		end,
		OffMessageCommand = function(self, params)
			if params.Wait then
				self:sleep(params.Wait)
			end
			self:queuecommand('CancelOverlay')
			MESSAGEMAN:Broadcast('HideBlur')
		end,
		CancelOverlayMessageCommand = function(self)
			screen:Cancel()
		end,
	}),
})