return Def.ActorFrame({
    InitCommand = function(self)
        self:Center()
    end,
    -- ステージが変化した時に発行
    FinishCommand = function(self)
        local song = GAMESTATE:GetCurrentSong()
        if song then
            local pnTiming = {}
            for p,pn in pairs(PlayerNumber) do
                local steps = GAMESTATE:GetCurrentSteps(W_PLAYER:IsEnabled(pn) and pn or W:APn(pn))
                if steps then
                    pnTiming[pn] = steps:GetTimingData()
                end
            end
            MESSAGEMAN:Broadcast('ChangedGameplaySong', {
                Song     = song,
                FirstSec = song:GetFirstSecond(),
                LastSec  = song:GetLastSecond(),
                Timing   = pnTiming,
            })
        end
    end,
    Def.ActorFrame({
        Def.Quad({
            BeforeLoadingNextCourseSongMessageCommand = function(self)
                self:zoomto(0, 0)
                self:xy(0, 0)
                self:diffuse(Color('Black'))
            end,
            SideBlackCommand = function(self)
                local width = self:GetParent():GetChild('BG'):GetWidth()
                self:horizalign(right)
                self:x(-width/2)
                self:zoomto((SCREEN_WIDTH - width)/2, SCREEN_HEIGHT)
                self:diffusealpha(0)
            end,
            StartCommand = function(self)
                self:diffusealpha(1)
            end,
        }),
        Def.Quad({
            BeforeLoadingNextCourseSongMessageCommand = function(self)
                self:zoomto(0, 0)
                self:xy(0, 0)
                self:diffuse(Color('Black'))
            end,
            SideBlackCommand = function(self)
                local width = self:GetParent():GetChild('BG'):GetWidth()
                self:horizalign(left)
                self:x(width/2)
                self:zoomto((SCREEN_WIDTH - width)/2, SCREEN_HEIGHT)
                self:diffusealpha(0)
            end,
            StartCommand = function(self)
                self:diffusealpha(1)
            end,
        }),
        Def.Sprite({
            OnCommand=function(self)
                self:LoadFromSongBackground(GAMESTATE:GetCurrentSong())
                self:scale_or_crop_background()
                self:xy(0, 0)
                self:diffusealpha(1)
            end,
            BeforeLoadingNextCourseSongMessageCommand=function(self)
                self:diffusealpha(0)
            end,
        }),
        Def.Sprite({
            Name = 'BG',
            BeforeLoadingNextCourseSongMessageCommand=function(self)
                self:LoadFromSongBackground(SCREENMAN:GetTopScreen():GetNextCourseSong())
                self:scale_or_crop_background()
                self:diffusealpha(0)
                self:xy(0, 0)
                self:GetParent():playcommand('SideBlack')
            end,
            StartCommand = function(self)
                self:diffusealpha(1)
            end,
        }),
        StartCommand = function(self)
            self:diffusealpha(0)
            self:sleep(0.2)
            self:diffusealpha(1)
            self:zoom(1.1)
            self:accelerate(0.5)
            self:zoom(1)
        end,
        FinishCommand = function(self)
            self:linear(0.2)
            self:diffusealpha(0)
        end,
    }),
    -- 上下帯
    Def.Quad({
        InitCommand = function(self)
            self:y(SCREEN_CENTER_Y)
            self:vertalign(bottom)
            self:diffuse(0.1, 0.1, 0.12, 0)
            self:zoomto(SCREEN_WIDTH+2, 50)
        end,
        StartCommand = function(self)
            self:linear(0.2)
            self:diffusealpha(1)
            self:zoomto(SCREEN_WIDTH+2, SCREEN_CENTER_Y)
            self:linear(0.2)
            self:zoomto(SCREEN_WIDTH+2, 140)
            self:sleep(0.2)
        end,
        FinishCommand = function(self)
            self:linear(0.2)
            self:diffusealpha(0)
            self:zoomto(SCREEN_WIDTH+2, 50)
        end,
    }),
    Def.Quad({
        InitCommand = function(self)
            self:y(-SCREEN_CENTER_Y)
            self:vertalign(top)
            self:diffuse(0.1, 0.1, 0.12, 0)
            self:zoomto(SCREEN_WIDTH+2, 50)
        end,
        StartCommand = function(self)
            self:linear(0.2)
            self:diffusealpha(1)
            self:zoomto(SCREEN_WIDTH+2, SCREEN_CENTER_Y)
            self:linear(0.2)
            self:zoomto(SCREEN_WIDTH+2, 140)
            self:sleep(0.2)
        end,
        FinishCommand = function(self)
            self:linear(0.2)
            self:diffusealpha(0)
            self:zoomto(SCREEN_WIDTH+2, 50)
        end,
    }),
})