-- 現在をこのバージョンとして扱う（引数が無い場合は現在のバージョン）
-- マイナーバージョンアップするたびにSetupが起動するのはうっとおしいのでここで指定すること
local setupVer = W:Ver({Main = '3.0.0', Sub = ''})
local setup = W_OPTION:ReadPref('Setup', 0)
setup = setup and tonumber(setup) or nil

-- グループのデフォルトカラー
YA_LIB.GROUP:AddKey('GroupColor', 'color', {Default = Color('Blue')})
local lockInput = true
-- 初期化
return Def.ActorFrame({
    InitCommand = function(self)
        if not setup or setup < setupVer then return end
        -- 専用オプションの初期値を設定
        local optList = {
            ContinueCombo           = 'TapNoteScore_W4',
            ComboColor              = 'DDR X',
            BreakComboMineHit       = true,
            BreakComboHoldLetGo     = true,
            RollCombo               = false,
            JudgmentsUnderField     = false,
            ComboUnderField         = true,
            CourseBannerStrictCheck = true,
            ComboAlways1            = false,
            JacketWheel             = false,
            ExecBrowser             = false,
            FrameColor              = '0, 0, 0, 0.35',
            FrameLight              = 'Auto',
            StartMusicTiming        = 'Quick',
            ScoreMode               = 'A',
            DifficultyLabel         = 'DDR',
            DifficultyColor         = 'DDR',
            JudgmentMode            = 'DDR',
            DefaultMeterType        = 'DDR',
            DefaultLyricType        = 'Default',
            LyricActorMax           = '32',
            HighScoreType           = true,
            FrameOverlay            = '0',
            GradeType               = 'StepMania',
        }
        for k,v in pairs(optList) do
            local val = W_OPTION:ReadPref(k)
            if val == nil then
                if v == false then
                    -- デフォルト値がfalse
                    W_OPTION:SavePref(k, (val ~= nil) and val or v)
                else
                    -- それ以外
                    W_OPTION:SavePref(k, (val == nil) and v or val)
                end
                if k == 'HighScoreType' then
                    PREFSMAN:SetPreference('PercentageScoring', true)
                end
            end
        end
        THEME:ReloadMetrics()
    end,
    OnCommand = function(self)
        if not setup or setup < setupVer then
            SCREENMAN:SetNewScreen('ScreenSetup')
            return
        end
        self:sleep(1)
        self:queuecommand('UnlockInput')
    end,
    UnlockInputCommand = function(self)
        lockInput = false
    end,
    CodeCommand = function(self, params)
        if lockInput then return end
        if params.Name == 'Next' then
            SCREENMAN:SetNewScreen('ScreenLogo')
        end
    end,
})