local size = 230
local Banner = LoadActor(W:Object('banner'), {
	Song  = W:Song(),
	Size  = size,
	Ratio = size/130,
	Cache = 0.3,
	Rate  = 0.25,
})

return Def.ActorFrame({
    LoadActor(THEME:GetPathB('ScreenWithMenuElements','background')),
    Def.ActorFrame({
        InitCommand = function(self)
            self:Center()
        end,
        Def.Quad({
            InitCommand = function(self)
                self:diffuse(0.1, 0.1, 0.12, 1.0)
                self:zoomto(SCREEN_WIDTH, SCREEN_HEIGHT)
            end,
            OnCommand = function(self)
                self:linear(0.2)
                self:diffusealpha(0)
            end,
            OffCommand = function(self)
                self:linear(0.2)
                self:diffusealpha(1)
            end,
        }),
        LoadActor(W:Object('boxshadow'), 'BannerFrame', {
            Length = 6,
            Color  = {1, 1, 1, 0.4},
            Center = {0, 0, 0, 0.8},
        })..{
            CallbackBannerCommand = function(self, params)
                self:playcommand('UpdateBoxShadow', {
                    Id         = 'BannerFrame',
                    Width      = params.MaxWidth,
                    Height     = params.RealHeight,
                    AnimeAlpha = true,
                })
            end,
        },
        -- バナー
        Banner:Actor()..{
            OnCommand = function(self, params)
                self:playcommand('UpdateBanner', {
                    Path = GAMESTATE:IsCourseMode()
                            and W_GRAPHICS:CourseBanner(GAMESTATE:GetCurrentCourse())
                            or W_GRAPHICS:SongBanner(W:Song()),
                })
            end,
        },
    }),
})