local screen
local cursor = 0

local function Input(params)
	local function OverlayCancel(...)
		local wait = ...
		screen:lockinput(0.25)
		screen:RemoveInputCallback(Input)
		MESSAGEMAN:Broadcast('Off', {Wait = wait or nil})
	end
    
	if not screen then return end
	if params.type == 'InputEventType_FirstPress'
	    or params.type == 'InputEventType_Repeat' then
        -- 変更せずに戻る
        if params.button == 'Back' then
            MESSAGEMAN:Broadcast('PlaySound', {
                Sound = 'Back',
            })
            OverlayCancel(0.2)
        -- 初期値
        elseif params.button == 'Select' then
        -- カーソル移動
        elseif params.button == 'Up' then
			cursor = cursor-1
            if cursor < 0 then
                cursor = 0
            else
                MESSAGEMAN:Broadcast('PlaySound', {
                    Sound = 'Cursor',
                })
                MESSAGEMAN:Broadcast('Scroll', {Cursor = cursor})
            end
		elseif params.button == 'Down' then
			cursor = cursor+1
            if cursor >= 1 then
                cursor = 1
            else
                MESSAGEMAN:Broadcast('PlaySound', {
                    Sound = 'Cursor',
                })
                MESSAGEMAN:Broadcast('Scroll', {Cursor = cursor})
            end
		elseif params.button == 'Left' then
		elseif params.button == 'Right' then
        -- 確定
		elseif params.button == 'Start' then
            MESSAGEMAN:Broadcast('PlaySound', {
                Sound = 'Start',
            })
            OverlayCancel(0.2)
		end
	end
end

-- 選曲の方のタイマーが0になった場合強制的に閉じる
local timerChild = getenv('WAIEI_ScreenTimer')
local function update(self, delta)
	if timerChild then
		if tonumber(timerChild:GetSeconds()) <= 0 then
			timerChild:SetSeconds(0.01)
			timerChild:start()
			screen:lockinput(0.25)
			screen:RemoveInputCallback(Input)
			MESSAGEMAN:Broadcast('Off', {Wait = 0})
		end
	end
end

-- キー操作
return Def.ActorFrame({
	Def.ActorFrame({
		OnCommand = function(self)
			screen = SCREENMAN:GetTopScreen()
			screen:AddInputCallback(Input)
			self:SetUpdateFunction(update)
            MESSAGEMAN:Broadcast('SetOptValue', tmpOpt)
		end,
		OffMessageCommand = function(self, params)
			if params.Wait then
				self:sleep(params.Wait)
			end
			self:queuecommand('CancelOverlay')
		end,
		CancelOverlayMessageCommand = function(self)
			screen:Cancel()
		end,
		-- 音
		LoadActor(THEME:GetPathS('Common', 'value'))..{
			PlaySoundMessageCommand = function(self, params)
				if params.Sound == 'Cursor' then
					self:play()
				end
			end,
		},
		LoadActor(THEME:GetPathS('Common', 'start'))..{
			PlaySoundMessageCommand = function(self, params)
				if params.Sound == 'Start' then
					self:play()
				end
			end,
		},
		LoadActor(THEME:GetPathS('Common', 'Cancel'))..{
			PlaySoundMessageCommand = function(self, params)
				if params.Sound == 'Back' then
					self:play()
				end
			end,
		},
	}),
})
