W:GroupScan()

YA_GROUP:SortSongs('DefaultGroup')
local ps = PREFSMAN:GetPreference('PercentageScoring')
W_OPTION:SavePref('HighScoreType', ps == true)
W_SCORE:SetGradeType(W_OPTION:ReadPref('GradeType'))

local curGameStepTypeList = {}
-- スタイル変更
local function SetStyle(add)
    local mPn = GAMESTATE:GetMasterPlayerNumber()
    local song = GAMESTATE:IsCourseMode() and GAMESTATE:GetCurrentCourse() or W:Song()
    if not song then return end
    local step = GAMESTATE:IsCourseMode() and GAMESTATE:GetCurrentTrail(mPn) or W:Steps(mPn)
    local currentStyle = step and step:GetStepsType() or GAMESTATE:GetCurrentStyle():GetStepsType()
    local index = 0
    for k,v in pairs(curGameStepTypeList) do
        if currentStyle == v:GetStepsType() then
            index = k
            break
        end
    end
    local stt
    for i=1, #curGameStepTypeList do
        index = index + add
        -- 変更可能なスタイルが無い
        if index < 1 or index > #curGameStepTypeList then
            return
        end
        -- 変更可能なスタイルを検索
        for k,v in pairs(GAMESTATE:IsCourseMode() and song:GetAllTrails() or song:GetAllSteps()) do
            if v:GetStepsType() == curGameStepTypeList[index]:GetStepsType() then
                stt = curGameStepTypeList[index]:GetStepsType()
                break
            end
        end
        if stt then
            break
        end
    end
    if not stt then
        return
    end
    for p,pn in pairs(PlayerNumber) do
        if W_PLAYER:IsEnabled(pn) then
            local dif = GAMESTATE:IsCourseMode() and step:GetDifficulty() or GAMESTATE:GetPreferredDifficulty(pn)
            local st
            for k,v in pairs(GAMESTATE:IsCourseMode() and song:GetAllTrails() or song:GetAllSteps()) do
                if v:GetStepsType() == stt then
                    -- 対象の難易度が存在しなかった場合一番低難易度を設定
                    if not st then
                        st = v
                    end
                    if v:GetDifficulty() == dif then
                        st = v
                        break
                    end
                end
            end
            if st then
                if GAMESTATE:IsCourseMode() then
                    GAMESTATE:SetCurrentTrail(pn, st)
                else
                    GAMESTATE:SetCurrentSteps(pn, st)
                end
                -- どうやっても固定できない（カーソルを動かすと戻る…）
                GAMESTATE:SetCurrentStyle(curGameStepTypeList[index])
                -- local styleName = split('_', stt)[3]
                -- GAMESTATE:ApplyGameCommand('style,'..string.lower(styleName))
            end
        end
    end
end

return Def.ActorFrame({
    OnCommand = function(self)
        curGameStepTypeList = W_STAGE:StyleList()
        SCREENMAN:GetTopScreen():lockinput(0.5)
        setenv('WAIEI_ScreenTimer', SCREENMAN:GetTopScreen():GetChild('Timer'))
    end,
    PlayerJoinedMessageCommand = function(self, params)
        curGameStepTypeList = W_STAGE:StyleList()
    end,
	CodeCommand = function(self, params)
		if GAMESTATE:IsEventMode() and params.Name == 'Options' then
			SCREENMAN:AddNewScreenToTop('ScreenSelectMusicOptions', 'BreakOptions')
		end
        if params.Name == 'PrevStyle' then
            SetStyle(-1)
        end
        if params.Name == 'NextStyle' then
            SetStyle(1)
        end
	end,
    -- Modeのテキストをリアルタイムで取得する方法が見つかるまでMusicWheelItem Rouletteに記載
    -- CurrentSongChangedMessageCommand = function(self)
    --     local song = GAMESTATE:GetCurrentSong()
    --     local wheel = SCREENMAN:GetTopScreen():GetMusicWheel()
    --     local group = wheel:GetSelectedSection()
    --     local order = GAMESTATE:GetSortOrder()
	-- 	   local name
	-- 	   local banner = THEME:GetPathG('Common', 'fallback banner')
    --     if song then
    --     else
    --     end
    --     if name then
    --         -- 曲情報を更新
    --         MESSAGEMAN:Broadcast('ChangedSong', {
    --             Name   = name,
    --             Song   = song,
    --         })
    --         -- メインバナーを更新
    --         MESSAGEMAN:Broadcast('UpdateMainBanner', {
    --             Path = banner,
    --         })
    --     end
    -- end,
    LoadActor('update'),
    Def.ActorFrame({
        LoadActor(THEME:GetPathG('main', 'bg'))..{
            OnCommand = function(self)
                self:Center()
                self:diffusealpha(1)
                self:sleep(0.2)
                self:diffusealpha(0)
            end,
        },
        Def.Quad({
            OnCommand = function(self)
                self:FullScreen()
                self:Center()
                self:diffuse(0, 0, 0, 0)
                self:linear(0.2)
                self:diffusealpha(1)
                self:linear(0.2)
                self:addy(SCREEN_HEIGHT)
                self:sleep(0.1)
                self:diffusealpha(0)
            end,
        }),
    }),
})