local listData = {}
local profiles = W_PLAYER:List()
for k, v in pairs(profiles) do
    listData[#listData + 1] = v.Name
end
if #listData <= 0 then
    listData[#listData + 1] = W_CUSTOM:String('Text', 'NoProfile')
end

-- モード
local M = W_CUSTOM:GV('Mode')

return Def.ActorFrame({
    InitCommand = function(self)
        self:Center()
    end,

    -- 一覧表示
    W_CUSTOM:Template('list', {
        Width  = 220,
        Height = 300,
        Line   = 30,
        Data   = listData,
    })..{
        InitCommand = function(self)
            self:xy(-200, 30)
        end,
    },
    LoadActor('bg'),
    LoadActor('description')..{
        InitCommand = function(self)
            self:y(-165)
        end,
    },

    LoadFont('Common Normal')..{
        Name = 'Title',
        Text = listData[1] or '',
        InitCommand = function(self)
            self:xy(110, -95)
            self:maxwidth(360)
            self:diffuse(Color('White'))
            self:strokecolor(Color('Outline'))
        end,
        ChangedProfileMessageCommand = function(self, params)
            self:stoptweening()
            self:settext(params.Name or '')
            self:diffusealpha(0)
            self:linear(0.1)
            self:diffusealpha(1)
        end,
    },
    LoadFont('Common Normal')..{
        Name = 'Body',
        Text = W_CUSTOM:String('Text', 'SelectProfile'),
        InitCommand = function(self)
            self:xy(110, 60)
            self:zoom(0.8)
            self:maxwidth(360 / 0.8)
            self:wrapwidthpixels(360 / 0.8)
            self:vertspacing(10)
            self:diffuse(Color('White'))
            self:strokecolor(Color('Outline'))
        end,
        ChangedModeMessageCommand = function(self, params)
            self:visible(params.Mode == M.Profile)
        end,
    },

    LoadActor('target'),

    W_CUSTOM:Template('Header'),
    W_CUSTOM:Template('Helper', {
        Text = THEME:GetString('ScreenCustom', 'HelperText'),
    }),
})
