-- モード
local M = W_CUSTOM:GV('Mode')
local slotList = {
    Main = {Y =   0, Title = W_CUSTOM:String('Text', 'MainLabel')},
    Sub1 = {Y =  60, Title = W_CUSTOM:String('Text', 'Sub1Label')},
    Sub2 = {Y = 120, Title = W_CUSTOM:String('Text', 'Sub2Label')},
}
local function ListActor(k, v)
    return Def.ActorFrame({
        InitCommand = function(self)
            self:visible(false)
        end,
        ChangedModeMessageCommand = function(self, params)
            self:visible(params.Mode == M.Slot)
        end,
        LoadFont('Common Small Normal')..{
            InitCommand = function(self)
                self:horizalign(left)
                self:zoom(0.5)
                self:xy(-70, -40 + v.Y)
                self:settext(v.Title)
            end,
        },
        Def.Quad({
            InitCommand = function(self)
                self:xy(110, -15 + v.Y)
                self:zoomto(260, 36)
                self:fadeleft(1)
                self:faderight(1)
                self:visible(false)
            end,
            ChangedSlotMessageCommand = function(self, params)
                self:visible((params.Slot and params.Slot == k) and true or false)
            end,
        }),
        Def.ActorFrame({
            InitCommand = function(self)
                self:xy(110, -15 + v.Y)
            end,
            ChangedSlotMessageCommand = function(self, params)
                self:diffusealpha((params.Slot and params.Slot == k) and 1 or 0.5)
            end,
            LoadFont('Common Normal')..{
                Text = '&MenuLeft;',
                InitCommand = function(self)
                    self:zoom(0.75)
                    self:x(-130)
                    self:diffuse(Color('White'))
                    self:strokecolor(Color('Outline'))
                end,
            },
            LoadFont('Common Normal')..{
                Text = '&MenuRight;',
                InitCommand = function(self)
                    self:zoom(0.75)
                    self:x(130)
                    self:diffuse(Color('White'))
                    self:strokecolor(Color('Outline'))
                end,
            },
            LoadFont('Common Normal')..{
                Text = W_CUSTOM:String('Text', 'NotSet'),
                InitCommand = function(self)
                    self:maxwidth(240)
                    self:diffuse(Color('White'))
                    self:strokecolor(Color('Outline'))
                end,
                UpdateTargetMessageCommand = function(self, params)
                    if params.Slot == k then
                        self:settext(params.Name or '')
                    end
                end,
            },
        }),
    })
end

local actors = Def.ActorFrame({})
for k,v in pairs(slotList) do
    actors[#actors+1] = ListActor(k, v)
end
actors[#actors+1] = Def.ActorFrame({
    InitCommand = function(self)
        self:xy(110, -10 + 160)
        self:visible(false)
    end,
    ChangedModeMessageCommand = function(self, params)
        self:visible(params.Mode == M.Slot)
    end,
    Def.Quad({
        InitCommand = function(self)
            self:zoomto(260, 36)
            self:fadeleft(1)
            self:faderight(1)
        end,
        ChangedSlotMessageCommand = function(self, params)
            self:visible(not params.Slot)
        end,
    }),
    LoadFont('Common Normal')..{
        Text = W_CUSTOM:String('Text', 'Save'),
        InitCommand = function(self)
            self:zoom(0.75)
            self:diffuse(Color('White'))
            self:strokecolor(Color('Outline'))
        end,
        ChangedSlotMessageCommand = function(self, params)
            self:diffusealpha((not params.Slot) and 1 or 0.5)
        end,
    },
})

return actors