return Def.ActorFrame({
    -- 何故かrouletteだけフォルダを含むすべての楽曲情報が取得できる挙動を利用
    SetCommand = function(self, params)
        local name
        local banner = THEME:GetPathG('Common', 'fallback banner')
        local song = nil
        if params.HasFocus then
            if params.Song then
                -- 楽曲
                name = params.Song:GetDisplayFullTitle()
                if params.Song:HasBanner() then
                    banner = params.Song:GetBannerPath()
                end
                song = params.Song
            elseif params.Course then
                -- コース
                name = YA_GROUP:GroupName(params.Course:GetTranslitFullTitle())
                local match = string.match(name, '(.+) Random$')
                if match then
                    name = YA_GROUP:GroupName(match)..' Random'
                end
                if params.Course:HasBanner() then
                    banner = W_GRAPHICS:CourseBanner(params.Course)
                end
            elseif params.Label and params.Label ~= "" then
                -- カスタム/Mode
                name = params.Label
            elseif params.Text and params.Text ~= "" then
                -- グループ
                banner = SONGMAN:GetSongGroupBannerPath(params.Text)
                name   = params.Text
            else
                -- ルーレット
                name = 'Random'
            end
            if name then
                -- 曲情報を更新
                MESSAGEMAN:Broadcast('ChangedSong', {
                    Name   = name,
                    Song   = song,
                })
                -- メインバナーを更新
                MESSAGEMAN:Broadcast('UpdateMainBanner', {
                    Path = banner,
                })
            end
        end
    end,
})