local name, scale, target = ...
name   = name or 'Blur'
scale  = scale or 60
target = target or 'Underlay'
local rander = string.lower(split(',',PREFSMAN:GetPreference('VideoRenderers'))[1]);
local shaderDisabled
if PREFSMAN:PreferenceExists('CustomShadersDisabled') then
    shaderDisabled = PREFSMAN:GetPreference('CustomShadersDisabled')
end
-- TODO: なんかいまいち良いぼかしにならないので一旦旧仕様に戻す
shaderDisabled = true

--if shaderDisabled == nil then shaderDisabled = true end
local function BGActor(self)
    if rander == 'd3d' then
        return Def.Actor({})
    else
        return Def.ActorFrameTexture({
            InitCommand = function(self)
                self:SetTextureName(name):EnableDepthBuffer(true)
                    :SetWidth(SCREEN_WIDTH):SetHeight(SCREEN_HEIGHT)
                    :Create()
            end,
            Def.ActorProxy({
                OnCommand = function(self)
                    self:SetTarget(SCREENMAN:GetTopScreen():GetChild('Underlay'))
                    if shaderDisabled then
                        self:zoom(1.0/scale)
                    end
                end,
            }),
        })
    end
end

local function TextureActor(self)
    if rander == 'd3d' then
        return Def.Quad({
            OnCommand = function(self)
                self:FullScreen()
                self:diffuse(0, 0, 0, 0.75)
                self:ztest(true)
            end,
        })
    else
        local function SpriteActor()
            if shaderDisabled then
                return Def.Sprite({
                    Texture = name,
                    OnCommand = function(self)
                        self:horizalign(left):vertalign(top)
                            :ztest(true):zoom(scale)
                    end,
                })
            end
            return Def.Sprite({
                Texture = name,
                Frag = 'shader/blur.frag',
                OnCommand = function(self)
                    local shader = self:GetShader()
                    shader:uniform1f('effectSize', math.max(0.5*scale, 1.0))
                    self:horizalign(left):vertalign(top)
                        :ztest(true)
                end,
            })
        end
        return Def.ActorFrame({
            SpriteActor(),
            Def.Quad({
                OnCommand = function(self)
                    self:FullScreen()
                    self:diffuse(0, 0, 0, 0.375)
                    self:ztest(true)
                end,
            }),
        })
    end
end

local function MaskActor(self)
    return Def.ActorFrame({
        Def.Quad({
            OnCommand = function(self)
                self:FullScreen()
                self:diffuse(0, 0, 0, 1)
                self:blend('BlendMode_NoEffect')
                self:clearzbuffer(true)
            end,
        }),
        Def.Quad({
            OnCommand = function(self)
                self:horizalign(left)
                self:vertalign(top)
                self:zwrite(true)
                self:blend('BlendMode_NoEffect')
            end,
            ResizeBlurMessageCommand = function(self, params)
                if params.Wait and params.Wait > 0 then
                    self:linear(params.Wait)
                end
                self:zoomto(SCREEN_WIDTH, params.Top)
            end,
        }),
        Def.Quad({
            OnCommand = function(self)
                self:horizalign(left)
                self:vertalign(bottom)
                self:y(SCREEN_BOTTOM)
                self:zwrite(true)
                self:blend('BlendMode_NoEffect')
            end,
            ResizeBlurMessageCommand = function(self, params)
                if params.Wait and params.Wait > 0 then
                    self:linear(params.Wait)
                end
                self:zoomto(SCREEN_WIDTH, SCREEN_HEIGHT-params.Bottom)
            end,
        }),
        Def.Quad({
            OnCommand = function(self)
                self:horizalign(left)
                self:vertalign(middle)
                self:y(SCREEN_CENTER_Y)
                self:zwrite(true)
                self:blend('BlendMode_NoEffect')
            end,
            ResizeBlurMessageCommand = function(self, params)
                if params.Wait and params.Wait > 0 then
                    self:linear(params.Wait)
                end
                self:zoomto(params.Left, SCREEN_HEIGHT)
            end,
        }),
        Def.Quad({
            OnCommand = function(self)
                self:horizalign(right)
                self:vertalign(middle)
                self:xy(SCREEN_RIGHT, SCREEN_CENTER_Y)
                self:zwrite(true)
                self:blend('BlendMode_NoEffect')
            end,
            ResizeBlurMessageCommand = function(self, params)
                if params.Wait and params.Wait > 0 then
                    self:linear(params.Wait)
                end
                self:zoomto(SCREEN_WIDTH-params.Right, SCREEN_HEIGHT)
            end,
        }),
    })
end

return {
    Background = BGActor,
    Texture    = TextureActor,
    Mask       = MaskActor,
}