-- 境界線
local params = ...
local fx = (params.From and params.From['X']) or 0
local fy = (params.From and params.From['Y']) or 0
local fz = (params.From and params.From['Z']) or 0
local col1 = (params.From and params.From['Color']) or color('#ffffffff')
local tx = (params.To and params.To['X']) or fx
local ty = (params.To and params.To['Y']) or fy
local tz = (params.To and params.To['Z']) or fz
local col2 = (params.To and params.To['Color']) or col1
local width = params.Width or 1
return Def.ActorMultiVertex({
    InitCommand = function(self)
        self:SetDrawState({Mode = 'DrawMode_LineStrip'})
        self:SetLineWidth(width)
        self:SetVertices(1, {
            {{fx, fy, fz}, col1},
            {{tx, ty, tz}, col2},
        })
    end,
    UpdateBorderMessageCommand = function(self, params)
        fx = (params.From and params.From['X']) or fx
        fy = (params.From and params.From['Y']) or fy
        fz = (params.From and params.From['Z']) or fz
        col1 = (params.From and params.From['Color']) or col1
        tx = (params.To and params.To['X']) or tx
        ty = (params.To and params.To['Y']) or ty
        tz = (params.To and params.To['Z']) or tz
        col2 = (params.To and params.To['Color']) or col2
        width = params.Width or width
        local anime = params.Anime or nil
        if anime then
            anime(self)
        end
        self:SetVertices(1, {
            {{fx, fy, fz}, col1},
            {{tx, ty, tz}, col2},
        })
        self:SetLineWidth(width)
        self:ForceStateUpdate()
    end
})