-- 四角形
local id, params = ...;
local width  = (params and params.Width) or 100
local height = (params and params.Height) or 100
local border = (params and params.Border) or 8
local color  = (params and params.Color) or {1.0, 1.0, 1.0, 1.0}

local posX = width/2
local posY = height/2

return Def.ActorFrame({
	-- 上辺
	Def.Quad({
		InitCommand = function(self)
			self:diffuse(color)
			self:horizalign(left)
			self:vertalign(top)
			self:xy(-posX, -posY)
			self:zoomto(width-border, border)
		end,
		SelectBoxColorMessageCommand=function(self, params)
			if params.Id == id then
				self:diffuse(params.Color)
			end
		end,
	}),
	-- 下辺
	Def.Quad({
		InitCommand = function(self)
			self:diffuse(color)
			self:horizalign(right)
			self:vertalign(bottom)
			self:xy(posX, posY)
			self:zoomto(width-border, border)
		end,
		SelectBoxColorMessageCommand=function(self, params)
			if params.Id == id then
				self:diffuse(params.Color)
			end
		end,
	}),
	-- 左辺
	Def.Quad({
		InitCommand = function(self)
			self:diffuse(color)
			self:horizalign(left)
			self:vertalign(bottom)
			self:xy(-posX, posY)
			self:zoomto(border, height-border)
		end,
		SelectBoxColorMessageCommand=function(self, params)
			if params.Id == id then
				self:diffuse(params.Color)
			end
		end,
	}),
	-- 右辺
	Def.Quad({
		InitCommand = function(self)
			self:diffuse(color)
			self:horizalign(right)
			self:vertalign(top)
			self:xy(posX, -posY)
			self:zoomto(border, height-border)
		end,
		SelectBoxColorMessageCommand=function(self, params)
			if params.Id == id then
				self:diffuse(params.Color)
			end
		end,
	}),
})
