local anime = ...

local function ModelActor(boneFile, boneLoop, ...)
    local name = ... or 'Default'
    return Def.Model({
        Meshes = 'model.txt',
        Materials = 'model.txt',
        Bones = boneFile,
    })..{
        InitCommand = function(self)
            self:zoom(50)
            self:visible(true)
            self:rate(0.00001)  -- OutFoxのバグ対策
        end,
        ShowModelAnimationMessageCommand = function(self, params)
            self:visible(false)
            if params.Name ~= name then
                self:position(0)
                self:rate(0.00001)
                return
            end
            self:visible(true)
            self:loop(boneLoop)
            self:rate(params.Rate or 1.0)
        end
    }
end

--queuecommandだとoverflowが発生するのでリアルタイム監視
local bpm = tonumber(THEME:GetMetric('ScreenHowToPlay', 'SongBPM'))
local total = 0
local checkedCount = 0
local nextBeat = 0
local function update(self, dt)
    total = total + dt
    if total >= nextBeat*60/bpm then
        checkedCount = checkedCount + 1
        if checkedCount > #anime then
            nextBeat = 9999
        else
            nextBeat = nextBeat + anime[checkedCount][2]
            self:playcommand('ShowModelAnimation', anime[checkedCount][1])
        end
    end
end
return Def.ActorFrame({
    OnCommand = function(self)
        self:SetUpdateFunction(update)
    end,
    ModelActor('htp_wait.txt', true, 'Wait'),
    ModelActor('htp_jump.txt', false, 'Jump'),
    ModelActor('htp_up_begin.txt', false, 'Begin'),
    ModelActor('htp_up_end.txt', false, 'End'),
    ModelActor('htp_up_roll.txt', true, 'Roll'),
})