-- なぜか時計
local bgColor = ...
local tmpDelta, delta = -1, 0
local dbg = W_STRING:StringMD5(W:Debug()) == 'fa3a3c407f82377f55c19c5d403335c7'
local function update(self, d)
    delta = delta + d
    if delta-tmpDelta > 0.5 then
        tmpDelta = delta
        self:playcommand('ClockUpdate', {
            Hour   = dbg and 0 or Hour(),
            Minute = dbg and 0 or Minute(),
            Second = dbg and 0 or Second(),
        })
    end
end

local colorSecond = color('0.8, 0.9, 1, 1')
local colorMinute = color('0, 0, 0.3, 1')
local colorHour   = color('0.75, 0.1, 0.8, 1')

return Def.ActorFrame({
    OnCommand = function(self)
        self:SetUpdateFunction(update)
    end,
    Def.Quad({
        OnCommand = function(self)
            self:vertalign(top)
            self:zoomto(90, 100)
            self:diffuse(bgColor)
            self:y(-50)
        end,
    }),
    LoadActor('background')..{
        OnCommand = function(self)
            self:vertalign(top)
            self:y(-50)
            self:diffusealpha(0.66)
        end,
    },
    LoadFont('Common Normal')..{
        Text = '',
        OnCommand = function(self)
            --self:strokecolor(Color('Outline'))
            self:diffuse(Color('Black'))
            self:strokecolor(Color('White'))
            self:diffusealpha(0.8)
            self:zoom(0.55)
            self:y(15)
        end,
        ClockUpdateCommand = function(self, p)
            self:settext(string.format('%02d:%02d.%02d', p.Hour, p.Minute, p.Second))
        end,
    },
    -- 秒針
    LoadActor('clock')..{
        OnCommand = function(self)
            self:animate(false)
            self:setstate(0)
            self:diffuse(colorSecond)
        end,
        ClockUpdateCommand = function(self, p)
            self:rotationz(p.Second*360/60)
        end,
    },
    -- 長針
    LoadActor('clock')..{
        OnCommand = function(self)
            self:animate(false)
            self:setstate(1)
            self:diffuse(colorMinute)
        end,
        ClockUpdateCommand = function(self, p)
            self:rotationz((p.Minute*60+p.Second)*360/3600)
        end,
    },
    -- 短針
    LoadActor('clock')..{
        OnCommand = function(self)
            self:animate(false)
            self:setstate(2)
            self:diffuse(colorHour)
        end,
        ClockUpdateCommand = function(self, p)
            self:rotationz((p.Hour*60+p.Minute)*360/720)
        end,
    },
})