local name = ...

local model = {
    Base = 'panel_base.txt',
    Red  = 'panel_red.txt',
    Blue = 'panel_blue.txt',
    RedMaterial  = '%s_panel_red_%s.txt',
    BlueMaterial = '%s_panel_blue_%s.txt',
}

return Def.ActorFrame({
    InitCommand = function(self)
        self:zoom(20)
    end,
    Def.Model({
        Meshes = model.Base,
        Materials = model.Base,
        Bones = model.Base,
    }),
    -- 上
    Def.Model({
        Meshes = model.Red,
        Materials = string.format(model.RedMaterial, name, 'up'),
        Bones = model.Red,
        InitCommand = function(self)
            self:z(2):rotationy(180)
        end,
    }),
    -- 下
    Def.Model({
        Meshes = model.Red,
        Materials = string.format(model.RedMaterial, name, 'down'),
        Bones = model.Red,
        InitCommand = function(self)
            self:z(-2)
        end,
    }),
    -- 左
    Def.Model({
        Meshes = model.Blue,
        Materials = string.format(model.BlueMaterial, name, 'left'),
        Bones = model.Blue,
        InitCommand = function(self)
            self:x(2):rotationy(90)
        end,
    }),
    -- 右
    Def.Model({
        Meshes = model.Blue,
        Materials = string.format(model.BlueMaterial, name, 'right'),
        Bones = model.Blue,
        InitCommand = function(self)
            self:x(-2):rotationy(-90)
        end,
    }),
})