local params = ...
local id = params.Id or nil
local width     = params.Width or 6
local height    = params.Height or 240
local dataCount = params.Count or 1
local barHeight = math.max(height / ((dataCount > 0) and dataCount or 1), 10)

-- スクロールバー
return Def.ActorFrame({
    Def.ActorFrame({
        Def.Quad({
            OnCommand = function(self)
                self:diffuse(1, 1, 1, 0.75)
                self:zoomto(width+2, height+2)
            end,
        }),
        Def.Quad({
            OnCommand = function(self)
                self:diffuse(0, 0, 0, 0.75)
                self:zoomto(width, height)
            end,
        }),
        Def.Quad({
            OnCommand = function(self)
                self:diffuse(1, 1, 1, 1)
                self:vertalign(top)
                self:zoomto(width, barHeight)
                self:diffuseshift()
                self:effectcolor1(1, 1, 1, 1)
                self:effectcolor2(1, 1, 1, 0.8)
            end,
            ScrollMenuMessageCommand = function(self, params)
                if params.Id and params.Id ~= id then
                    return
                end
                self:stoptweening()
                if not params.Init then
                    self:linear(0.2)
                end
                self:y(-height/2 + ((dataCount > 1) and ((height - barHeight) * (params.Cursor-1) / (dataCount-1)) or 0))
            end,
            UpdateBarCommand = function(self)
                barHeight = math.max(height / ((dataCount > 0) and dataCount or 1), 10)
                self:zoomto(width, barHeight)
            end,
        }),
        ScrollMenuMessageCommand = function(self, params)
            if params.Id and params.Id ~= id then
                return
            end
            self:stoptweening()
            if not params.Init then
                self:linear(0.2)
                self:diffusealpha(1)
                self:zoomx(1)
                self:x(0)
                self:sleep(2.0)
                self:linear(0.2)
            end
            self:zoomx(0.25)
            self:x(width*0.75/2)
            self:diffusealpha(0.5)
        end,
        UpdateScrollDataMessageCommand = function(self, params)
            if params.Id and params.Id ~= id then
                return
            end
            dataCount = #params.Data
            self:playcommand('UpdateBar', params)
        end,
    }),
})