-- スペクトラムバーもどき（1本分）
local params = ...;
local width  = (params and params.Width) or 50
local height = (params and params.Height) or 20
local border = (params and params.Border) or 1
local color  = (params and params.Color) or {1.0, 1.0, 1.0, 0.3}
local max    = (params and params.Max) or 100
local min    = (params and params.Min) or 10
local cycle  = (params and params.Cycle) or 100
local displayMax = max
local displayMin = min
local cacheBeat  = 0

local t=Def.ActorFrame{};

for i=0, 9 do
    t[#t+1] = Def.Quad{
        InitCommand = function(self)
            self:diffuse(color)
            self:zoomto(width-border*2, height-border*2)
            self:vertalign(bottom)
            self:y((5-i) * height)
        end;
        UpdateSpectrumCommand=function(self, params)
            self:finishtweening()
            self:diffusealpha((params.Value-5 >= i*10) and color[4] or color[4]*0.2)
        end;
    }
end

t.ScreenUpdateMessageCommand=function(self, params)
    -- BPMが速い場合は少し早めにリセットしないと違和感ある
    local beat  = math.round(((params.Beat+ math.min(GAMESTATE:GetSongBPS()*0.1, 0.5) )*100)%cycle)
    local pos   = GAMESTATE:GetSongPosition():GetMusicSeconds()
    local range = 0
    if cacheBeat > beat then
        range = math.random(max-min)
        displayMax = math.min(max + range/2, 100)
        displayMin = math.max(min - range/2, 0)
    end
    cacheBeat = beat
    local nextValue = ((cycle - beat) * (displayMax - displayMin) / cycle + displayMin)
    if params.Gameplay then
        -- 曲開始時にふわっと表示する
        if pos < 0 then
            nextValue = 0
        elseif pos < 0.2 then
            nextValue = nextValue * pos*5
        end
    end
    self:playcommand('UpdateSpectrum', {
        Value = nextValue,
    })
end

return t;
