-- pss:GetPercentDancePoints()を使うとリアルタイムの値が取れないので
-- JudgmentMessageCommandを監視してメッセージを飛ばす
-- Gameplayに対して1回だけ呼び出す

local ss = STATSMAN:GetCurStageStats()
local pss = {}
local score = {
    PLAYER_1 = {},
    PLAYER_2 = {},
}
-- 計算用のスコアの重み（Metricsから読みこむ）
local weight = {
    CheckpointHit = 0,
    CheckpointMiss = 0,
    Held = 0,
    HitMine = 0,
    MissedHold = 0,
    LetGo = 0,
    Miss  = 0,
    ProW1 = 0,
    ProW2 = 0,
    ProW3 = 0,
    ProW4 = 0,
    ProW5 = 0,
    W1 = 0,
    W2 = 0,
    W3 = 0,
    W4 = 0,
    W5 = 0,
}
local maxDP = {}
local curMaxDP = {}

for k,v in pairs(weight) do
    weight[k] = tonumber(THEME:GetMetric('ScoreKeeperNormal', 'PercentScoreWeight'..k))
end

-- タップ、ホールド、チェックポイントの最高得点
local maxWeight = {
    TapNoteScore     = weight.W1 or 3,
    HoldNoteScore    = weight.Held or 3,
    CheckpointScore  = weight.CheckpointHit or 3,
}

for pn in ivalues(PlayerNumber) do
    pss[pn]   = W_PLAYER:IsEnabled(pn) and ss:GetPlayerStageStats(pn) or nil
    score[pn] = 0
    maxDP[pn] = 0
    curMaxDP[pn] = 0
end

return Def.Actor({
    InitCommand = function(self)
        for pn in ivalues(PlayerNumber) do
            if W_PLAYER:IsEnabled(pn) then
                maxDP[pn] = W_SCORE:MaxDPScore(pn)
            end
        end
    end,
    JudgmentMessageCommand = function(self, params)
        for pn in ivalues(PlayerNumber) do
            if pss[pn] and params.Player == pn and params.TapNoteScore and
            params.TapNoteScore ~= 'TapNoteScore_Invalid' and
            params.TapNoteScore ~= 'TapNoteScore_AvoidMine' and
            -- params.TapNoteScore ~= 'TapNoteScore_HitMine' and
            -- params.TapNoteScore ~= 'TapNoteScore_CheckpointMiss' and
            -- params.TapNoteScore ~= 'TapNoteScore_CheckpointHit' and
            params.TapNoteScore ~= 'TapNoteScore_None' then
                local isAutoPlay = (GAMESTATE:GetPlayerState(pn):GetPlayerController() ~= 'PlayerController_Human')
                self:stoptweening()
                self:sleep(0.01)    -- 確実にスコアが入ったタイミングになるためのwait
                if pss[pn]:GetFailed() then
                    return
                end
                if params.HoldNoteScore then
                    curMaxDP[pn] = curMaxDP[pn] + maxWeight.HoldNoteScore
                    if not isAutoPlay then
                        local shortName = ToEnumShortString(params.HoldNoteScore)
                        score[pn] = score[pn] + (weight[shortName] or 0)
                    end
                elseif params.TapNoteScore then
                    if params.TapNoteScore ~= 'TapNoteScore_HitMine' then
                        curMaxDP[pn] = curMaxDP[pn] + maxWeight.TapNoteScore
                        -- Checkpointは事前に数を取得できないのでその都度最大値も加算する
                        if params.TapNoteScore == 'TapNoteScore_CheckpointMiss'
                            or params.TapNoteScore == 'TapNoteScore_CheckpointHit' then
                            maxDP[pn] = maxDP[pn] + maxWeight.CheckpointScore
                        end
                    end
                    if not isAutoPlay then
                        local shortName = ToEnumShortString(params.TapNoteScore)
                        score[pn] = score[pn] + (weight[shortName] or 0)
                    end
                end
                MESSAGEMAN:Broadcast("TargetScore",{
                    Player   = pn,
                    Self     = 100.0 * math.max(score[pn], 0) / maxDP[pn],  -- 現在のスコア(%)
                    CurMaxDP = curMaxDP[pn],    -- 全てを最高判定で取得した時の現在のスコア(DP)
                    FullDP   = maxDP[pn],       -- 全てを最高判定で取得した時の最終的なスコア(DP)
                })
            end
        end
    end
})