local baseY = {
    Standard = W_PLAYER:StepZoneY('Standard'),
    Reverse  = W_PLAYER:StepZoneY('Reverse'),
}
local option = {
	{X =   0, YStandard = baseY.Standard + 320, YReverse = baseY.Reverse + 160,  Mini = false},
	{X = -68, YStandard = baseY.Reverse + 195,  YReverse = baseY.Standard + 295, Mini = true},
	{X =  68, YStandard = baseY.Reverse + 195,  YReverse = baseY.Standard + 295, Mini = true},
}

local function TargetActor(pn, index, name)
    if name == '' then
        return Def.ActorFrame({})
    end
    return Def.ActorFrame({
        -- ターゲットスコア
        LoadActor(W:Object('target'), pn, name, option[index].Mini)..{
            InitCommand = function(self)
                self:x(W_PLAYER:StepZoneX(pn) + option[index].X)
                self:y(W_PLAYER:IsReverse(pn) and option[index].YReverse or option[index].YStandard)
            end,
            -- WAIEI Coreのスクロール方向変更メッセージ
            ChangeReverseMessageCommand = function(self, params)
                if params.Player ~= pn then return end
                self:stoptweening()
                self:linear(0.2)
                self:y((params.New >= 0.5) and option[index].YReverse or option[index].YStandard)
            end,
        },
    })
end

local t = Def.ActorFrame({
    OnCommand = function(self)
        self:diffusealpha(0)
        self:sleep(0.4)
        self:sleep(W_TIMER:GameJacketSleep())
        self:linear(0.2)
        self:diffusealpha(1)
    end,
    -- リアルタイムで差分を取得する
    -- Gameplayで1回だけ呼び出す
    LoadActor('count'),
})
for pn in ivalues(PlayerNumber) do
    if W_PLAYER:IsEnabled(pn) then
        local pnSetting = W_PLAYER:ReadPref(pn, 'EnableTarget')
        if pnSetting == 'On' then
            local target = W_PLAYER:ReadPref(pn, 'TargetList', '')
            local targetList = split('|', target or '')
            -- 設定ファイルは存在するが、全ターゲット設定なしの場合はハイスコアのみ表示する
            if string.gsub(target, '|', '') == '' and pnSetting == 'On' then
                targetList[1] = W_TARGET:List()[1]
            end
            for i=1, #targetList do
                if i > 3 then break end
                t[#t+1] = TargetActor(pn, i, targetList[i])
            end
        end
    end
end

return t