local pn, ss = ...
local mpn = GAMESTATE:GetMasterPlayerNumber()
local pss = ss:GetPlayerStageStats(pn)
local song = ss:GetPlayedSongs()[1]
local steps = GAMESTATE:IsCourseMode()
                and GAMESTATE:GetCurrentTrail(mpn)
                or pss:GetPlayedSteps()[1]
local dif = steps:GetDifficulty()

return Def.ActorFrame({
    -- 難易度
    Def.ActorFrame({
        -- 難易度名
        LoadFont('Common Bold')..{
            Text = "",
            OnCommand = function(self)
                self:horizalign(left)
                self:vertalign(top)
                if GAMESTATE:IsCourseMode() then
                    self:x(-80 - (SCREEN_WIDTH-640)/8 - (W:IsP1(pn) and 0 or 40))
                else
                    self:x(-80 - (SCREEN_WIDTH-640)/8)
                end
                self:zoom(0.6)
                self:maxwidth((90 + (SCREEN_WIDTH-640)/8) / 0.6)
                self:diffuse(W_DIF:Color(dif))
                self:settext(GAMESTATE:IsCourseMode() and W_DIF:Course(dif) or W_DIF:Name(dif, steps))
            end,
        },
        -- メータータイプ
        LoadFont('Common Normal')..{
            Text = "",
            OnCommand = function(self)
                self:horizalign(left)
                self:vertalign(top)
                if GAMESTATE:IsCourseMode() then
                    self:x(-80 - (SCREEN_WIDTH-640)/8 - (W:IsP1(pn) and 0 or 40))
                else
                    self:x(-80 - (SCREEN_WIDTH-640)/8)
                end
                self:y(15)
                self:zoom(0.5)
                self:maxwidth(90 / 0.5)
                self:diffuse(BoostColor(Color('White'), 0.66))
                self:settext(GAMESTATE:IsCourseMode() and 'COURSE' or YA_GROUP:MeterType(song))
            end,
        },
        -- 数値
        LoadFont('Common Bold')..{
            Text = "",
            OnCommand = function(self)
                self:horizalign(right)
                self:vertalign(top)
                self:diffuse(W_DIF:Color(dif))
                if GAMESTATE:IsCourseMode() then
                    self:xy(W:IsP1(pn) and 120 or 80, 2)
                    self:zoom(1.2)
                    self:maxwidth(100 / 1.2)
                    local dList = W_DIF:TrailMinMax(steps, steps:GetDifficulty(), false)
                    self:settext(dList.Min..' - '..dList.Max)
                else
                    self:x(80)
                    self:zoom(1.4)
                    self:maxwidth(70 / 1.4)
                    self:settext(steps:GetMeter())
                end
            end,
        },
    }),
})
