local pn, width = ...
local noteScore = getenv('WAIEI_NoteScore')[pn] or {}

-- 判定ラベル
local function LabelActor(params)
    return Def.ActorFrame({
        LoadFont('Common small normal')..{
            Text = string.upper(params.Text),
            OnCommand = function(self)
                self:horizalign(params.Horizalign or left)
                self:vertalign(top)
                self:diffuse(params.Color)
                self:zoom(0.35)
            end,
        },
    })
end

-- 判定数値（初期）
local function DetailActor(params)
    return Def.ActorFrame({
        LoadFont('waiei2 Score Numbers')..{
            Text = string.upper(params.Text),
            OnCommand = function(self)
                self:horizalign(params.Horizalign or right)
                self:vertalign(top)
                self:diffuse(params.Color)
                self:zoom(0.8)
                if params.MaxWidth then
                    self:maxwidth(params.MaxWidth / 0.8)
                end
            end,
        },
    })
end

local FSActor = Def.ActorFrame({})

FSActor[#FSActor+1] = Def.Quad({
    OnCommand = function(self)
        self:horizalign(left)
        self:xy(-1, 7)
        self:diffuse(1, 1, 1, 0.5)
        self:zoomto(width+2, 16)
    end,
})
local faseAndSlow = noteScore.Fast + noteScore.Slow
if noteScore.Fast > 0 then
    FSActor[#FSActor+1] =Def.Quad({
        OnCommand = function(self)
            self:horizalign(left)
            self:xy(0, 7)
            self:diffuse(BoostColor(Color('Blue'), 0.65))
            self:zoomto(width * noteScore.Fast / faseAndSlow, 14)
        end,
    })
end
if noteScore.Slow > 0 then
    FSActor[#FSActor+1] =Def.Quad({
        OnCommand = function(self)
            self:horizalign(right)
            self:xy(width, 7)
            self:diffuse(BoostColor(Color('Red'), 0.5))
            self:zoomto(width * noteScore.Slow / faseAndSlow, 14)
        end,
    })
end
-- FAST
FSActor[#FSActor+1] =DetailActor({
    Text  = (noteScore.Fast or 0),
    Color = BoostColor(Color('Blue'), 1.33),
    Horizalign = left,
})..{
    OnCommand = function(self)
        self:xy(2, 0)
        self:zoom(0.9)
    end,
}
-- SLOW
FSActor[#FSActor+1] = DetailActor({
    Text  = (noteScore.Slow or 0),
    Color = Color('Red'),
    Horizalign = right,
})..{
    OnCommand = function(self)
        self:xy(width-2, 0)
        self:zoom(0.9)
    end,
}
FSActor[#FSActor+1] = LabelActor({
    Text  = 'FAST',
    Color = BoostColor(Color('Blue'), 1.33),
})..{
    OnCommand = function(self)
        self:xy(0, -10)
    end,
}
FSActor[#FSActor+1] = LabelActor({
    Text  = 'SLOW',
    Color = Color('Red'),
    Horizalign = right
})..{
    OnCommand = function(self)
        self:xy(width, -10)
    end,
}

return FSActor
