local pn, pss = ...
local pnTargetSetting = W_PLAYER:ReadPref(pn, 'EnableTarget')
local target = (pnTargetSetting == 'On')
                and W_PLAYER:ReadPref(pn, 'TargetList', '')
                or ''
-- 設定ファイルは存在するが、全ターゲット設定なしの場合はハイスコアのみ表示する
if string.gsub(target, '|', '') == '' and pnTargetSetting == 'On' then
    target = W_TARGET:List()[1]..'||'
end
local targetList = split('|', target or '')
local width = 200
local height = (not target or target == '') and 85 or ((targetList[2] == '' and targetList[3] == '') and 110 or 135)
local profile = PROFILEMAN:GetProfile(pn)
local areaWidth = width
local areaHeight = 120

local function PlayerTargetActor(pn)
    local playerActor = Def.ActorFrame({})
    local function TargetActor(pn, index, name, mini)
        return LoadActor(W:Object('target/static/static'), pn, name, mini, true)..{
            InitCommand = function(self)
                self:x((index%2) * areaWidth/2 - areaWidth/4)
                if index < 2 then
                    self:y((targetList[2] == '' and targetList[3] == '') and 20 or 2)
                else
                    self:y((areaHeight/4+5) * math.floor(index/2) + ((targetList[1] == '') and -10 or 4))
                end
                self:zoom(0.8)
            end,
        }
    end
    if not target or target == '' then return playerActor end
    for i=1, #targetList do
        if i > 3 then break end
        playerActor[#playerActor+1] = TargetActor(pn, i, targetList[i], true)
    end
    return playerActor
end

local tmp, playerScore, playerIsNoPlay = W_SCORE:HighDPScore(pn, true)

return Def.ActorFrame({
    LoadActor(W:Object('boxshadow'), 'Note'..(W:IsP1(pn) and 1 or 2), {
        Width  = width,
        Height = height,
        Center  = BoostColor(W_PLAYER:Color(pn), 0.5),
        Color  = color('#00000064'),
        Length = 30,
    })..{
        OnCommand = function(self)
            self:playcommand('UpdateBoxShadow', {
                Id         = 'Note'..(W:IsP1(pn) and 1 or 2),
                Width  = width+2,
                Height = height+2,
            })
        end,
    },
    Def.Quad({
        InitCommand = function(self)
            self:diffuse(0, 0, 0, 0.66)
            self:zoomto(width, height)
        end,
    }),
    -- プレイヤー名
    Def.ActorFrame({
        InitCommand = function(self)
            self:x(-width/2 + 50)
            self:y(-height/2 + 15)
        end,
        LoadFont('Common Normal')..{
            Name = 'PlayerName',
            Text = W_PLAYER:Name(pn),
            InitCommand = function(self)
                self:horizalign(left)
                self:diffuse(Color('White'))
                self:zoom(0.75)
                self:maxwidth((width-55)/0.75)
            end,
        },
        LoadFont('Common Normal')..{
            Name = 'PlayerScore',
            Text = W_STRING:DP(0.01*playerScore),
            InitCommand = function(self)
                self:horizalign(left)
                self:y(20)
                self:diffuse(Color('White'))
                self:zoom(0.5)
            end,
        },
        W_AVATAR:Frame(W_PLAYER:PlayerAvatar(pn), 'TaregetScorePlayer'..pname(pn), {
            Flip = true,
            Mini = false,
            Color = BoostColor(W_PLAYER:Color(pn), 0.66),
            Type  = 0,
            RandomNum = W_AVATAR:RandomNum(W_PLAYER:Name(pn)),
        })..{
            InitCommand = function(self)
                self:xy(-25, 10)
                self:zoom(0.35)
            end,
        },
    }),
    Def.Quad({
        InitCommand = function(self)
            self:horizalign(right)
            self:x(width/2)
            self:y(-height/2+27)
            self:diffuse(1, 1, 1, 0.33)
            self:zoomto(width*2/3, 1)
            self:fadeleft(1)
        end,
    }),
    PlayerTargetActor(pn)..{
        Name = 'Target',
        InitCommand = function(self)
            self:y(-20)
            self:zoom(1)
            self:playcommand('SetPlayerScore', {
                Score    = playerScore,
                IsNoPlay = playerIsNoPlay,
            })
        end,
    },
    -- カロリー
    Def.ActorFrame({
        InitCommand = function(self)
            self:y(height/2-10)
        end,
        LoadFont('Common Small Normal')..{
            Text = THEME:GetString('ScreenEvaluation', 'CaloriesBurned'),
            InitCommand = function(self)
                self:diffuse(Color('White'))
                self:zoom(0.3)
                self:horizalign(left)
                self:vertalign(top)
                self:xy(-width/2+6, -15)
            end,
        },
        LoadFont('Common Small Normal')..{
            Text = commify(string.format('%4.1f', pss:GetCaloriesBurned()), ','),
            InitCommand = function(self)
                self:diffuse(Color('White'))
                self:zoom(0.5)
                self:horizalign(right)
                self:vertalign(bottom)
                self:xy(-width/8, 0)
                self:maxwidth((width/2 - width/8) / 0.5)
            end,
        },
        LoadFont('Common Small Normal')..{
            Text = 'Kcal',
            InitCommand = function(self)
                self:diffuse(Color('White'))
                self:zoom(0.35)
                self:horizalign(left)
                self:vertalign(bottom)
                self:xy(-width/8+4, 1)
            end,
        },
        LoadFont('Common Small Normal')..{
            Text = THEME:GetString('ScreenEvaluation', 'CaloriesBurnedToday'),
            InitCommand = function(self)
                self:diffuse(Color('White'))
                self:zoom(0.3)
                self:horizalign(left)
                self:vertalign(top)
                self:xy((width/2)-width/2+4, -15)
            end,
        },
        LoadFont('Common Small Normal')..{
            Text = commify(string.format('%4.1f', profile:GetCaloriesBurnedToday()), ','),
            InitCommand = function(self)
                self:diffuse(Color('White'))
                self:zoom(0.5)
                self:horizalign(right)
                self:vertalign(bottom)
                self:xy((width/2)-width/8-4, 0)
                self:maxwidth((width/2 - width/8 - 4) / 0.5)
            end,
        },
        LoadFont('Common Small Normal')..{
            Text = 'Kcal',
            InitCommand = function(self)
                self:diffuse(Color('White'))
                self:zoom(0.35)
                self:horizalign(left)
                self:vertalign(bottom)
                self:xy((width/2)-width/8, 1)
            end,
        },
    }),
})
