local pn, pss = ...
local p = W:IsP1(pn) and 1 or 2

local width = 180
local addWidth = 200
local height = 265

local JudgmentBg = LoadActor(W:Object('radius'), {
    Id     = 'JudgmentBg'..p,
    Width  = width,
    Height = height,
    Color  = color('0, 0.1, 0.12, 0.8'),
    Radius = 4,
    Cell   = {1, 1, 1, 1, 1, 1, 0, 0, 0},
})
local JudgmentBorder = LoadActor(W:Object('radius'), {
    Id     = 'JudgmentBorder'..p,
    Width  = width,
    Height = height,
    Color  = color('1.0, 1.0, 1.0, 0.25'),
    Radius = 5,
    Cell   = {1, 1, 1, 1, 1, 1, 0, 0, 0},
    Fill   = false,
    Mini   = true,
})
local playerColor = W_PLAYER:Color(pn)

return Def.ActorFrame({
    Def.ActorFrame({
        InitCommand = function(self)
            self:y(height/2)
        end,
        -- 背景
        Def.ActorFrame({
            JudgmentBg:Actor(),
            JudgmentBorder:Actor(),
            HideDetailMessageCommand = function(self)
                self:stoptweening()
                self:linear(0.2)
                self:x(0)
                if GAMESTATE:IsPlayerEnabled(PLAYER_1) then
                    self:playcommand('UpdateRadius', {
                        Id    = 'JudgmentBg1',
                        Width = width,
                        Wait  = 0.2,
                    })
                    self:playcommand('UpdateRadius', {
                        Id    = 'JudgmentBorder1',
                        Width = width,
                        Wait  = 0.2,
                    })
                end
                if GAMESTATE:IsPlayerEnabled(PLAYER_2) then
                    self:playcommand('UpdateRadius', {
                        Id    = 'JudgmentBg2',
                        Width = width,
                        Wait  = 0.2,
                    })
                    self:playcommand('UpdateRadius', {
                        Id    = 'JudgmentBorder2',
                        Width = width,
                        Wait  = 0.2,
                    })
                end
            end,
            ShowDetailMessageCommand = function(self, params)
                if pn ~= params.Player then return end
                self:stoptweening()
                self:playcommand('UpdateRadius', {
                    Id    = 'JudgmentBg'..((params.Player == PLAYER_1) and 1 or 2),
                    Width = width + addWidth,
                    Wait  = 0.2,
                })
                self:playcommand('UpdateRadius', {
                    Id    = 'JudgmentBorder'..((params.Player == PLAYER_1) and 1 or 2),
                    Width = width + addWidth,
                    Wait  = 0.2,
                })
                self:linear(0.2)
                self:x((params.Player == PLAYER_1) and addWidth/2 or -addWidth/2)
            end,
        }),
        -- 判定 上ぞろえにする
        LoadActor('judgment', pn, pss)..{
            InitCommand = function(self)
                self:xy(0, 30-height/2)
            end,
        },
        Def.ActorFrame({
            HideDetailMessageCommand = function(self)
                self:stoptweening()
                self:linear(0.2)
                self:x(0)
            end,
            ShowDetailMessageCommand = function(self, params)
                if pn ~= params.Player then return end
                self:stoptweening()
                self:linear(0.2)
                self:x((params.Player == PLAYER_1) and 0 or -200)
            end,
            Def.ActorFrame({
                HideDetailMessageCommand = function(self)
                    self:stoptweening()
                    self:linear(0.2)
                    self:diffusealpha(1)
                end,
                ShowDetailMessageCommand = function(self, params)
                    if pn ~= params.Player then return end
                    self:stoptweening()
                    self:linear(0.2)
                    self:diffusealpha(0)
                end,
                -- プレイヤー名
                Def.Quad({
                    InitCommand = function(self)
                        self:xy(0, -120)
                        self:zoomto(170, 14)
                        self:diffuse(BoostColor({playerColor[1], playerColor[2], playerColor[3], 0.5}, 0.5))
                    end,
                }),
                LoadFont('Common Small Normal')..{
                    Text = W_PLAYER:Name(pn),
                    InitCommand = function(self)
                        self:xy(0, -120)
                        self:zoom(0.45)
                        self:maxwidth(160/0.45)
                    end,
                },
            }),
            -- FastSlow
            LoadActor('fastslow', pn, width-30)..{
                OnCommand = function(self)
                    self:xy(-width/2+15, height/2-30)
                end,
            },
        }),
    }),
})