local pn, pss, isSummary = ...
isSummary = (isSummary ~= nil) and isSummary or false

-- ハイスコアとの差（diffPercent>=0の場合ハイスコア）
local hiPercent, curPercent = 0, 0
if not isSummary then 
    hiPercent, curPercent = W_SCORE:HighDPScore(pn)
end
local diffPercent, diffColor = W_STRING:DiffAndColor(curPercent, hiPercent)

-- +-ラベル
local Value = function(params)
    return Def.ActorFrame({
        InitCommand = function(self)
            self:y(params.Y)
        end,
        LoadFont('waiei2 Score Numbers')..{
            OnCommand = function(self)
                self:horizalign(right)
                self:diffuse(params.Color)
                self:x(params.Width/2)
                self:zoom(0.8)
                self:settext(params.Value)
            end,
        },
        LoadFont('Common small normal')..{
            Text = string.upper(params.Label),
            OnCommand = function(self)
                self:horizalign(left)
                self:diffuse(params.Color)
                self:x(-params.Width/2)
                self:zoom(0.35)
                if params.Stroke then
                    self:strokecolor(params.Stroke)
                end
            end,
        },
    })
end

local fcColor = BoostColor(W_SCORE:FCColor(pn, pss) or color('#ffffff00'), 0.8)
local fullcombo = LoadActor(W:Object('radius'), {
    Id     = 'FullCombo'..ToEnumShortString(pn),
    Width  = 68,
    Height = 12,
    Color  = {fcColor[1], fcColor[2], fcColor[3], 0.5},
    Radius = 8,
    Mini   = false,
    --Fill   = false,
    Blend  = 'BlendMode_Add',
})


return Def.ActorFrame({
    Def.Sprite({
        Name = 'Grade',
        OnCommand = function(self)
            local grade = W_SCORE:GetGrade(pss)
            local x = isSummary and 90 + math.min((SCREEN_WIDTH-640)/4, 50) or 90
            self:Load(THEME:GetPathG('', 'ScreenEvaluation/_parts/grade/'..ToEnumShortString(grade)))
            self:shadowlength(1)
            self:zoom(0.5)
            self:xy(W:IsP1(pn) and -x or x, isSummary and 5 or 20)
        end,
    }),
    -- スコア
    Def.ActorFrame({
        Name = 'Score',
        OnCommand = function(self)
            self:xy(W:IsP1(pn) and 125 or 5, 0)
        end,
        -- パーセント
        LoadFont('waiei2 Combo Numbers')..{
            OnCommand = function(self)
                self:horizalign(right)
                self:diffuse(Color('White'))
                self:strokecolor(0, 0, 0, 0.5)
                self:zoom(0.8)
                if pss:GetPercentDancePoints() >= 1 then
                    self:settext('100%')
                else
                    self:settext(W_STRING:DP(pss:GetPercentDancePoints()))
                end
            end,
        },
        -- FC
        Def.ActorFrame({
            OnCommand = function(self)
                local fcColor = W_SCORE:FCColor(pn, pss)
                self:xy(-103, 22)
                self:visible((pss:GetBestFullComboTapNoteScore() and fcColor) and true or false)
            end,
            fullcombo:Actor()..{
                OnCommand = function(self)
                    self:y(0)
                end,
            },
            LoadFont('Common Small Normal')..{
                OnCommand = function(self)
                    local best = pss:GetBestFullComboTapNoteScore()
                    local text = ''
                    --self:strokecolor(Color('Black'))
                    self:y(-0.33)
                    self:zoom(0.4)
                    self:maxwidth(60/0.4)
                    if best == 'TapNoteScore_W3' then
                        text = 'FULLCOMBO'
                    elseif best then
                        --text = string.sub(W_JUDGMENT:Name(best), 0, 1)..'FC'
                        text = W_JUDGMENT:Name(best)..' FC'
                    else
                        text = ''
                    end
                    self:settext(string.upper(text))
                end,
            }
        }),
        -- +-
        Value({
            Color  = diffColor,
            Stroke = color('0, 0, 0, 0.5'),
            Label  = '',
            Value  = W_STRING:DP(0.01*diffPercent, true),
            Width  = 130,
            Y      = 20,
        })..{
            OnCommand = function(self)
                self:x(-65)
                self:visible(not isSummary)
            end
        },
        -- SCORE
        Value({
            Color  = Color('White'),
            Stroke = color('0, 0, 0, 0.5'),
            Label  = 'SCORE',
            Value  = W_STRING:Number(pss:GetScore()),
            Width  = 130,
            Y      = 40,
        })..{
            OnCommand = function(self)
                self:x(-65)
            end
        },
    }),
})
