local function LineActor(width)
    return Def.Quad({
        InitCommand = function(self)
            self:diffuse(1, 1, 1, 0.9)
            self:zoomto(width, 1)
            self:fadeleft(1)
            self:faderight(1)
        end,
    })
end

return Def.ActorFrame({
    InitCommand = function(self)
        self:Center()
    end,
    OnCommand = function(self)
        self:zoomy(0)
        self:diffusealpha(0)
        self:decelerate(0.2)
        self:zoomy(1)
        self:diffusealpha(1)
    end,
    OffCommand = function(self)
        self:decelerate(0.2)
        self:zoomx(0)
        self:diffusealpha(0)
    end,
    Def.Quad({
        InitCommand = function(self)
            self:diffuse(0.3, 0.3, 0.3, 0.75)
            self:zoomto(SCREEN_WIDTH+2, 300)
        end,
    }),
    LineActor(SCREEN_WIDTH+2)..{
        InitCommand = function(self)
            self:y(-150)
        end,
    },
    LineActor(SCREEN_WIDTH+2)..{
        InitCommand = function(self)
            self:y(150)
        end,
    },
    LoadActor('text')..{
        InitCommand = function(self)
            self:diffusealpha(0)
            self:y(-20)
            self:addy(50)
        end,
        OnCommand = function(self)
            self:sleep(0.2)
            self:decelerate(0.2)
            self:diffusealpha(1)
            self:addy(-50)
        end,
    },
    LoadFont('Common Normal')..{
        Text = 'G a m e O v e r',
        InitCommand = function(self)
            self:strokecolor(Color('White'))
            self:diffuseblink()
            self:effectcolor1(color('#336699ff'))
            self:effectcolor2(color('#6699ffff'))
            self:diffusealpha(0)
            self:y(110)
            self:addy(50)
        end,
        OnCommand = function(self)
            self:sleep(0.4)
            self:decelerate(0.2)
            self:diffusealpha(1)
            self:addy(-50)
        end,
    },
})