local fullWidth, fullHeight = ...
fullWidth  = (fullWidth or 256)
fullHeight = (fullHeight or 36)
local width  = 0.1 * fullWidth
local height = 0.1 * fullHeight
local max   = {100, 100, 100,  70,  50,  55,  70, 100,  90,  60}
local min   = { 65,  70,  40,  30,  30,  30,  50,  75,  60,  40}
local cycle = {100, 100, 100, 100,  90,  75,  75,  50,  50,  50}
local spectrumsActor = Def.ActorFrame({})
if not GAMESTATE:IsDemonstration() then
    return spectrumsActor
end
local frame = LoadActor(W:Object('radius'), {
    Id     = 'demo',
    Width  = fullWidth + 10,
    Height = fullHeight + 22,
    Radius = 8,
    Color  = color('0, 0, 0, 0.8'),
})
for i=0, 9 do
    spectrumsActor[#spectrumsActor+1] = LoadActor(W:Object('spectrum'), {
        Width  = width,
        Height = height,
        Max    = max[i+1],
        Min    = min[i+1],
        Cycle  = cycle[i+1],
    })..{
        InitCommand=function(self)
            self:x((i-4.5) * width)
        end,
    }
end
return Def.ActorFrame({
    OnCommand = function(self)
        self:x(SCREEN_WIDTH + fullWidth)
        self:y(SCREEN_HEIGHT - fullHeight/2 - 105)
        self:sleep(math.min(W_TIMER:GameJacketSleep(), 1.8))
        self:bouncebegin(0.4)
        self:zoom(0.9)
        --self:x(THEME:GetMetric('ScreenGameplay', 'PlayerP2OnePlayerOneSideX'))
        self:x(SCREEN_WIDTH - 160)
    end,
    frame:Actor()..{
        OnCommand = function(self)
            self:y(9)
        end,
    },
    LoadFont('Common Small Normal')..{
        Text = YA_GROUP:GroupName(GAMESTATE:GetCurrentSong():GetGroupName()),
        OnCommand = function(self)
            self:y(28)
            self:diffuse(0.75, 0.75, 0.75, 1)
            self:zoom(0.5)
            self:maxwidth(fullWidth/0.5)
        end,
    },
    spectrumsActor,
})
