-- BPM
local pn, strokeColor = ...
local width  = 90
local height = 10

return Def.ActorFrame{
    LoadFont('Common Small Normal')..{
        Text = 'BPM',
        InitCommand = function(self)
            self:horizalign(left)
            self:vertalign(top)
            self:xy(-width/2, -height/2+2)
            self:diffuse(Color('White'))
            self:zoom(0.4)
            if (strokeColor[4] > 0) then
                self:strokecolor(strokeColor)
            end
        end,
    },
    LoadFont('Common Normal')..{
        InitCommand = function(self)
            self:horizalign(right)
            self:vertalign(bottom)
            self:xy(width/2, height/2)
            self:diffuse(Color('White'))
            self:zoom(0.65)
            self:settextf('%4.1f', 0)
            if (strokeColor[4] > 0) then
                self:strokecolor(strokeColor)
            end
        end,
        ScreenUpdateMessageCommand = function(self, params)
            local steps  = W:Steps(pn)
            local timing = steps and steps:GetTimingData() or nil
            if timing then
                local beat = timing:GetBeatFromElapsedTime(params.Sec)
                local bpm  = timing:GetBPMAtBeat(beat)
                self:settextf('%4.1f', bpm)
            end
        end,
    },
};