-- 出来るだけ重くしないために事前にテーブルを作成しておく
local function InitNoteScore()
    local columns = GAMESTATE:GetCurrentStyle():ColumnsPerPlayer()
    local tableData = {}
    for i=1, columns do
        tableData[i] = {}
        for tap in pairs(TapNoteScore) do
            tableData[i][TapNoteScore[tap]] = 0
        end
    end
    tableData.Fast = 0
    tableData.Slow = 0
    tableData.UsingAutoplay = false
    return tableData
end
local noteScore = {
    PlayerNumber_P1 = InitNoteScore(),
    PlayerNumber_P2 = InitNoteScore(),
}
setenv('WAIEI_NoteScore', noteScore)

return Def.Actor({
    JudgmentMessageCommand=function(self, params)
        if not params.Player
            or not params.TapNoteScore
            or not params.Notes then
             return
        end
        if not noteScore[params.Player].UsingAutoplay
            and (GAMESTATE:GetPlayerState(params.Player):GetPlayerController() ~= 'PlayerController_Human') then
                noteScore[params.Player].UsingAutoplay = true
        end
        for i, note in pairs(params.Notes) do
            local check = noteScore[params.Player][i][params.TapNoteScore]
            noteScore[params.Player][i][params.TapNoteScore] = check + 1
        end
        if params.TapNoteScore ~= 'TapNoteScore_W1' and params.TapNoteScore ~= 'TapNoteScore_Miss' then
            if params.Early then
                noteScore[params.Player].Fast = noteScore[params.Player].Fast+1
            else
                noteScore[params.Player].Slow = noteScore[params.Player].Slow+1
            end
        end
    end,
    OffCommand = function(self)
        setenv('WAIEI_NoteScore', noteScore)
    end,
})