local pn = ...

if not GAMESTATE:IsPlayerEnabled(pn) then return Def.ActorFrame({}) end
local playerReverse = GAMESTATE:GetPlayerState(pn):GetCurrentPlayerOptions():Reverse() ~= 0
local posY = {
    Speed = {
        Standard = SCREEN_CENTER_Y + W_PLAYER:StepZoneY('Standard') + 55,
        Reverse  = SCREEN_CENTER_Y + W_PLAYER:StepZoneY('Reverse') - 55,
    },
    Option = {
        Standard = SCREEN_CENTER_Y + W_PLAYER:StepZoneY('Standard') + 35,
        Reverse  = SCREEN_CENTER_Y + W_PLAYER:StepZoneY('Reverse') - 35,
    },
}
local function SorR(text)
    return text and 'Reverse' or 'Standard'
end
local steps
local bpmAverage = 0
return Def.ActorFrame({
    Def.ActorFrame({
        OnCommand = function(self)
            self:xy(W_PLAYER:StepZoneX(pn), posY.Speed[SorR(playerReverse)])
            self:diffusealpha(0)
        end,
        ChangedGameplaySongMessageCommand = function(self, params)
            steps = W:Steps(pn)
            local speed = YA_SCROLL:CurrentSpeed(pn)
            bpmAverage = W_PLAYER:AverageBPM(pn, speed.Mod, speed.Speed)
        end,
        ChangeSpeedMessageCommand = function(self, params)
            if params.Player ~= pn then return end
            self:playcommand('ShowSpeed', params)
        end,
        ChangeReverseMessageCommand = function(self, params)
            if params.Player ~= pn then return end
            playerReverse = (params.New == 1)
            self:finishtweening()
            self:linear(0.2)
            self:y(posY.Speed[SorR(playerReverse)])
        end,
        ShowSpeedCommand = function(self)
            self:finishtweening()
            self:diffusealpha(1)
            self:sleep(1.5)
            self:linear(0.2)
            self:y(posY.Speed[SorR(playerReverse)])
            self:diffusealpha(0)
        end,
        Def.ActorFrame({
            Name = 'Speed',
            InitCommand = function(self)
                self:y(5)
            end,
            Def.Quad({
                OnCommand = function(self)
                    self:zoomto(W_PLAYER:StepZoneW(pn), 32)
                    self:diffuse(0, 0, 0, 0.5)
                    self:fadeleft(0.5)
                    self:faderight(0.5)
                end,
            }),
            LoadFont('Common Normal')..{
                Text = '',
                OnCommand = function(self)
                    self:diffuse(1, 1, 1, 1)
                    self:zoom(0.6)
                    self:xy(-55, -4)
                end,
                ShowSpeedCommand = function(self, params)
                    self:settext('&MenuLeft;')
                end,
            },
            LoadFont('Common Normal')..{
                Text = '',
                OnCommand = function(self)
                    self:diffuse(1, 1, 1, 1)
                    self:zoom(0.6)
                    self:xy(55, -4)
                end,
                ShowSpeedCommand = function(self, params)
                    self:settext('&MenuRight;')
                end,
            },
            LoadFont('Common Normal')..{
                Text = '',
                OnCommand = function(self)
                    self:diffuse(1, 1, 1, 1)
                    self:zoom(0.75)
                    self:y(-5)
                end,
                ShowSpeedCommand = function(self, params)
                    self:settext(params.Display)
                end,
            },
            LoadFont('Common Small Bold')..{
                Text = '',
                OnCommand = function(self)
                    self:strokecolor(Color('Outline'))
                    self:diffuse(BoostColor(W_PLAYER:Color(pn), 1.2))
                    self:zoom(0.4)
                    self:y(10)
                end,
                ShowSpeedCommand = function(self, params)
                    local bpm = W_PLAYER:HighspeedBPM(pn, params.Mod, params.Speed, steps)
                    self:settextf(
                        '%s (avg. %s)',
                        bpm,
                        bpmAverage < 0 and '???' or math.round(bpmAverage * ((params.Mod == 'm') and 1 or params.Speed)))
                end,
            },
        }),
    }),
    Def.ActorFrame({
        Name = 'Option',
        OnCommand = function(self)
            self:xy(W_PLAYER:StepZoneX(pn), posY.Option[SorR(playerReverse)])
        end,
        ChangeReverseMessageCommand = function(self, params)
            if params.Player ~= pn then return end
            self:stoptweening()
            self:linear(0.2)
            self:y(posY.Option[SorR(params.New == 1)])
        end,
        LoadFont('Common Small Normal')..{
            Text = W_PLAYER:GameplayMods(pn),
            OnCommand = function(self)
                self:diffuse(1, 1, 1, 0)
                self:strokecolor(Color('Outline'))
                self:maxwidth(W_PLAYER:StepZoneW(pn)/0.35)
                self:zoomx(2)
                self:zoomy(0)
                self:sleep(1.5)
                self:linear(0.2)
                self:diffusealpha(1)
                self:zoomx(0.35)
                self:zoomy(0.35)
                --self:sleep(math.min(W_TIMER:GameJacketSleep(), 2.5))
                self:sleep(2.5)
                self:linear(0.2)
                self:diffusealpha(0)
                self:zoomx(2)
                self:zoomy(0)
            end,
        },
    }),
})