local edge = 1.0/128
local filter = {
    PlayerNumber_P1 = W_PLAYER:ReadPref(PLAYER_1, 'ScreenFilter') or W_OPTION:Name('Off'),
    PlayerNumber_P2 = W_PLAYER:ReadPref(PLAYER_2, 'ScreenFilter') or W_OPTION:Name('Off'),
}
for k,v in pairs(filter) do
    filter[k] = (v ~= W_OPTION:Name('Off')) and tonumber(split('%%', v)[1]) * 0.01 or 0
end

-- [ja] 曲情報は曲が変更されたときに1回更新する
local song
local start = 0
local last  = 0

local function PlayerFilterActor(pn)
    if not GAMESTATE:IsPlayerEnabled(pn) then
        return Def.ActorFrame({
            Name = 'ScreenFilter'..pname(pn)
        })
    end
    local playerChild
    local isEdit = false
    return Def.ActorFrame({
        Name = 'ScreenFilter'..pname(pn),
        Def.Quad({
            InitCommand=function(self)
                self:y(SCREEN_CENTER_Y)
                self:diffuse(Color("Black"))
                self:visible(false)
            end,
            OnCommand=function(self)
                self:x(W_PLAYER:StepZoneX(pn))
                self:zoomto(W_PLAYER:StepZoneW(pn)+20, SCREEN_HEIGHT)
                if edge > 0 then
                    self:fadeleft(edge)
                    self:faderight(edge)
                end
                self:diffusealpha(filter[pn])
                isEdit = GAMESTATE:GetCurrentSteps(pn):IsAnEdit()
            end,
            ScreenUpdateMessageCommand = function(self, params)
                if params and song then
                    local beat = params.Beat
                    if ((beat >= start-8.0) or isEdit) and (beat <= last) then
                        playerChild = playerChild or SCREENMAN:GetTopScreen():GetChild('Player'..pname(pn));
                        self:zoomtowidth(W_PLAYER:StepZoneRealW(pn)+20)
                        self:rotationz(playerChild and playerChild:GetRotationZ() or 0)
                        self:visible(true)
                    else
                        self:visible(false)
                    end
                end
            end,
        }),
    })
end

return Def.ActorFrame({
    ChangedGameplaySongMessageCommand=function(self,params)
        if params.Song then
            song  = params.Song
            start = song:GetFirstBeat()
            last  = song:GetLastBeat()
        end
    end,
    PlayerFilterActor(PLAYER_1),
    PlayerFilterActor(PLAYER_2),
})
