local pn = ...
if not W_PLAYER:IsEnabled(pn) or W_PLAYER:ReadPref(pn, 'SpeedAssist', W_OPTION:Name('Off')) == W_OPTION:Name('Off') then
    return Def.ActorFrame({})
end
local steps, td
local po = GAMESTATE:GetPlayerState(pn):GetCurrentPlayerOptions()
local x, baseW = W_PLAYER:StepZoneX(pn), W_PLAYER:StepZoneW(pn)
local w = baseW
local y = {Standard = W_PLAYER:StepZoneY('Standard'), Reverse = W_PLAYER:StepZoneY('Reverse')}
local yHeight = (y.Reverse - y.Standard)

-- 矢印ひとつの大きさ
local columnW = tonumber(THEME:GetMetric('ArrowEffects', 'ArrowSpacing'))

local aType = {
    Delay = 1,
    Stop  = 2,
    Warp  = 3,
    BPM   = 4,
}
local sType = {
    Speed  = 1,
    Scroll = 2,
}
local maxBpm = 0

local actorMax = 12

local assistList = {}
local speedList  = {}
local curIndex, curSpeedIndex = 1, 1
local showList = {}
local totalDelta = 0
local curSpeed, speedV, oldSpeedV = {}, 1.0, 1.0
local curScroll = 1.0
local tmpDelta = 0
local playerChild
local function Update(self, delta)
    totalDelta = totalDelta + delta
    if totalDelta - tmpDelta > 1.0/120 and td then
        tmpDelta = totalDelta
        local cnt = 0
        for k,v in pairs(showList) do
            cnt = cnt+1
        end
        -- 表示アイコンなしでCModの場合＝意図的にプレイヤーがC速を選択しているのでSpeedAssistは無効
        if cnt <= 0 and po:CMod() then return end

        local ms = GAMESTATE:GetCurMusicSeconds()
        
        playerChild = playerChild or SCREENMAN:GetTopScreen():GetChild('Player'..pname(pn));

        if cnt > 0 then
            -- SPEEDが定義されている
            if curSpeed.Time then
                if ms < curSpeed.End and (curSpeed.End ~= curSpeed.Time) then
                    local per = (ms - curSpeed.Time) / (curSpeed.End - curSpeed.Time)
                    speedV = curSpeed.Value * per + oldSpeedV * (1.0-per)
                else
                    speedV = curSpeed.Value
                end
            end
        end
        local mini = (1.0 - (po:Mini()/2))
        w = W_PLAYER:StepZoneRealW(pn)
        local reverse = po:Reverse()%2
        reverse = (reverse>1) and 2-reverse or reverse

        local mmod = po:MMod()
        local params = {
            Y = playerChild:GetY() + (y.Standard + yHeight*reverse) + (yHeight/2 * po:Centered() * ((reverse>=0.5) and -1 or 1)),
            Time  = ms,
            Beat  = td:GetBeatFromElapsedTime(ms),
            Speed = (mmod and mmod/maxBpm or po:XMod() or 1.0) * speedV * curScroll * mini,
            Reverse = reverse,             -- Std 0 ...  1 Rev
            Reverse2 = (0.5-reverse)*2,    -- Std 1 ... -1 Rev
        }
        for k,v in pairs(showList) do
            -- 毎フレーム更新用メッセージ
            params.Index = v
            params.ListIndex = k
            self:GetChild('AssistFrame')
                :GetChild('Assist'..((v-1)%actorMax+1))
                :playcommand('UpdateAssist', params)
        end

        -- BPM・停止関連
        for i=curIndex, #assistList do
            if cnt >= actorMax then
                break
            end
            -- 3秒前からチェック
            if (assistList[i].Time - 3) <= ms then
                showList[#showList+1] = i
                self:GetChild('AssistFrame')
                    :GetChild('Assist'..((i-1)%actorMax+1))
                    :playcommand('ShowAssist', {Index = i})
                self:playcommand('AssistOrder')
                curIndex = i+1
                cnt = cnt+1
            else
                break
            end
        end

        -- Speed・Scroll関連
        for i=curSpeedIndex, #speedList do
            -- スピード、スクロール系は到達してから処理
            if speedList[i].Time <= ms then
                if speedList[i].Type == sType.Speed then
                    oldSpeedV = curSpeed.Value or 1.0
                    curSpeed = {Time = speedList[i].Time, End = speedList[i].End, Value = speedList[i].Value}
                elseif speedList[i].Type == sType.Scroll then
                    curScroll = speedList[i].Value
                end
                curSpeedIndex = i+1
            else
                break
            end
        end

    end
end


local function AssistActor()
    local aa = Def.ActorFrame({
        FOV = 60,
        Name = 'AssistFrame',
        AssistOrderCommand = function(self)
            self:SortByDrawOrder()
        end,
    })
    -- 左右のアイコン
    local function IconActor(isLeft)
        local function StopLineActor(isLeft)
            if not isLeft then
                return Def.Actor({})
            end
            return LoadActor('line')..{
                SetPartsCommand = function(self, params)
                    self:x(w/2 + 16)
                    self:zoomtowidth(w)
                    self:diffuse(params.Bottom or color('0, 0, 0, 0'))
                end,
                UpdateAssistCommand = function(self)
                    self:zoomtowidth(w)
                end,
            }
        end
        return Def.ActorFrame({
            InitCommand = function(self)
                self:x(x)
            end,
            UpdateAssistCommand = function(self)
                if isLeft then
                    self:x(x-w/2 - 16)
                else
                    self:x(x+w/2 + 16)
                    self:rotationy(180)
                end
            end,
            LoadActor('icon')..{
                InitCommand = function(self)
                    self:animate(false)
                end,
                SetPartsCommand = function(self, params)
                    self:diffuse(params.Color)
                    self:setstate(params.Icon)
                end,
            },
            -- 停止長さアイコン
            Def.ActorFrame({
                UpdateAssistCommand = function(self, params)
                    local index = params.Index
                    if not assistList[index] then return end
                    if assistList[index].Type == aType.Stop or assistList[index].Type == aType.Delay then
                        -- 停止-1秒～終了の間だけ表示
                        local endTime = assistList[index].Time + assistList[index].Value
                        if params.Time >= (assistList[index].Time-1) and params.Time < endTime then
                            local bpm = td:GetBPMAtBeat(assistList[index].Beat)
                            local offset = (endTime - math.max(params.Time, assistList[index].Time)) * (columnW*bpm/60) * params.Speed
                            self:diffusealpha((params.Time >= (assistList[index].Time-0.5)) and 1 or (1-(assistList[index].Time-0.5-params.Time)*2))
                            self:rotationx(params.Reverse * 180)
                            self:y(offset * params.Reverse2)
                        else
                            self:diffusealpha(0)
                        end
                    end
                end,
                LoadActor('icon')..{
                    InitCommand = function(self)
                        self:animate(false)
                        self:setstate(5)
                    end,
                    SetPartsCommand = function(self, params)
                        self:diffuse(params.Bottom or color('0, 0, 0, 0'))
                    end,
                },
                StopLineActor(isLeft),
            }),
            -- -- デバッグ
            -- LoadFont('Common Normal')..{
            --     Text = '',
            --     UpdateAssistCommand = function(self, params)
            --         self:settext(params.Index)
            --     end,
            -- },
        })
    end
    for i=1, actorMax do
        -- Attributeやrainbowを使用した時に半透明が使えるようにフレームで囲む
        aa[#aa+1] = Def.ActorFrame({
            Name = 'Assist'..i,
            InitCommand = function(self)
                self:diffusealpha(0)
            end,
            ShowAssistCommand = function(self, params)
                local index = params.Index
                self:finishtweening()
                self:draworder(-params.Index)
                self:diffusealpha(0)
                if assistList[index].Type == aType.BPM then
                    -- 10以上BPMが変わる時のみ
                    if math.abs(assistList[index].Diff) >= 10 then
                        self:playcommand('SetParts', {
                            Color  = (assistList[index].Diff > 0) and Color('Red') or color('0, 0.75, 1, 1'),
                            Icon   = (assistList[index].Diff > 0) and 0 or 1,
                            Height = 20,
                        })
                    else
                        self:playcommand('SetParts', {
                            Color  = color('0, 0, 0, 0'),
                            Icon   = (assistList[index].Diff > 0) and 0 or 1,
                            Height = 0,
                        })
                    end
                elseif assistList[index].Type == aType.Warp then
                    self:playcommand('SetParts', {
                        Color  = Color('Purple'),
                        Icon   = 4,
                        Height = 10,
                    })
                elseif assistList[index].Type == aType.Stop then
                    self:playcommand('SetParts', {
                        Color  = color('0, 1, 0, 1'),
                        Icon   = 2,
                        Height = 0,
                        Bottom = Color('White'),
                    })
                elseif assistList[index].Type == aType.Delay then
                    self:playcommand('SetParts', {
                        Color  = Color('Yellow'),
                        Icon   = 3,
                        Height = 0,
                        Bottom = Color('White'),
                    })
                end
            end,
            UpdateAssistCommand = function(self, params)
                local index = params.Index
                if not assistList[index] then return end
                self:finishtweening()
                if (assistList[index].Time - params.Time) > 1.5 then
                    self:diffusealpha(1.0 - ((assistList[index].Time-1.5) - params.Time))
                else
                    self:diffusealpha(1)
                end
                local offset = math.max((assistList[index].Beat - params.Beat), 0)*columnW * params.Speed
                self:y(params.Y + offset * params.Reverse2)
                -- 非表示設定
                if assistList[index].Type == aType.BPM then
                    -- ステップゾーンを超えてから0.25秒
                    if params.Time - assistList[index].Time > 0.25 then
                        self:diffusealpha(0)
                        showList[params.ListIndex] = nil
                    elseif params.Time > assistList[index].Time then
                        self:diffusealpha(1.0 - (params.Time - assistList[index].Time)*4)
                    end
                elseif assistList[index].Type == aType.Warp then
                    -- ステップゾーンを超えてから0.25秒
                    if params.Time - assistList[index].Time > 0.25 then
                        self:diffusealpha(0)
                        showList[params.ListIndex] = nil
                    elseif params.Time > assistList[index].Time then
                        self:diffusealpha(1.0 - (params.Time - assistList[index].Time)*4)
                    end
                else
                    -- ストップとディレイ
                    -- 停止が終わってから0.25秒
                    if params.Time - (assistList[index].Time + assistList[index].Value) > 0.25 then
                        self:diffusealpha(0)
                        showList[params.ListIndex] = nil
                    elseif params.Time > (assistList[index].Time + assistList[index].Value) then
                        self:diffusealpha(1.0 - (params.Time - (assistList[index].Time + assistList[index].Value))*4)
                    end
                end
            end,
            LoadActor('line')..{
                InitCommand = function(self)
                    self:x(x)
                end,
                SetPartsCommand = function(self, params)
                    self:zoomtowidth(w)
                    self:diffuse(params.Color)
                end,
                UpdateAssistCommand = function(self)
                    self:zoomtowidth(w)
                end,
            },
            Def.Quad({
                InitCommand = function(self)
                    self:x(x)
                    self:vertalign(top)
                    self:y(-1)
                    self:zoomto(0, 0)
                end,
                SetPartsCommand = function(self, params)
                    self:diffuse(params.Color)
                    self:diffusealpha(0.5)
                    self:zoomto(w + 10, params.Height)
                    self:fadebottom(1)
                end,
                UpdateAssistCommand = function(self, params)
                    self:zoomtowidth(w + 10)
                    self:rotationx(params.Reverse * 180)
                end,
            }),
            -- 右アイコン
            IconActor(false),
            -- 左アイコン
            IconActor(true),
        })
    end
    return aa
end

return Def.ActorFrame({
    OnCommand = function(self)
        self:SetUpdateFunction(Update)
    end,
    ChangedGameplaySongMessageCommand = function(self, params)
        self:playcommand('LoadAssist')
    end,
    LoadAssistCommand = function(self)
        if GAMESTATE:IsCourseMode() then
            local index = GAMESTATE:GetCourseSongIndex()
            steps = GAMESTATE:GetCurrentTrail(pn):GetTrailEntry(index):GetSteps()
        else
            steps = GAMESTATE:GetCurrentSteps(pn)
        end
        td = steps:GetTimingData()
        assistList = {}
        speedList  = {}
        curIndex, curSpeedIndex = 1, 1
        curSpeed, speedV, oldSpeedV = {}, 1.0, 1.0
        totalDelta = 0
        tmpDelta = 0
        -- BPM変動
        local bpmList = {}
        for k,v in pairs(td:GetBPMsAndTimes()) do
            local data = split('=', v)
            local numData = {tonumber(data[1]), tonumber(data[2])}
            bpmList[#bpmList+1] = {
                Type  = aType.BPM,
                Beat  = numData[1],
                Time  = td:GetElapsedTimeFromBeat(numData[1]),
                Value = numData[2],
                Diff  = (k == 1) and numData[2] or (numData[2] - bpmList[#bpmList].Value),
            }
            if numData[2] > maxBpm then
                maxBpm = numData[2]
            end
        end
        -- DISPLAYBPMが0より大きい場合はそれを優先
        if steps:GetDisplayBPMType() ~= 'DisplayBPM_Random' then
            local display = steps:GetDisplayBpms()
            if display[2] > 0 then
                maxBpm = display[2]
            end
        end
        -- 最大BPMは最大でもMModHighCapの値
        if maxBpm > tonumber(THEME:GetMetric('Player', 'MModHighCap')) then
            maxBpm = tonumber(THEME:GetMetric('Player', 'MModHighCap'))
        end
        -- 1つ目(初期BPM)はデータ不要
        for k,v in pairs(bpmList) do
            if k > 1 then
                assistList[#assistList+1] = v
            end
        end
        -- Stop
        for k,v in pairs(td:GetStops()) do
            local data = split('=', v)
            local numData = {tonumber(data[1]), tonumber(data[2])}
            assistList[#assistList+1] = {
                Type  = aType.Stop,
                Beat  = numData[1],
                Time  = td:GetElapsedTimeFromBeat(numData[1]),
                Value = numData[2],
            }
        end
        -- Delay
        for k,v in pairs(td:GetDelays()) do
            local data = split('=', v)
            local numData = {tonumber(data[1]), tonumber(data[2])}
            assistList[#assistList+1] = {
                Type  = aType.Delay,
                Beat  = numData[1],
                Time  = td:GetElapsedTimeFromBeat(numData[1]) - numData[2],
                Value = numData[2],
            }
        end
        -- Warp
        for k,v in pairs(td:GetWarps()) do
            local data = split('=', v)
            local numData = {tonumber(data[1]), tonumber(data[2])}
            assistList[#assistList+1] = {
                Type  = aType.Warp,
                Beat  = numData[1],
                Time  = td:GetElapsedTimeFromBeat(numData[1]),
                Value = numData[2],
            }
        end
        -- Speed
        for k,v in pairs(td:GetSpeeds()) do
            local data = split('=', v)
            local numData = {tonumber(data[1]), tonumber(data[2]), tonumber(data[3])}
            speedList[#speedList+1] = {
                Type  = sType.Speed,
                Beat  = numData[1],
                Time  = td:GetElapsedTimeFromBeat(numData[1]),
                Value = numData[2],
                End   = td:GetElapsedTimeFromBeat(numData[1] + numData[3]),
            }
        end
        -- Scroll
        for k,v in pairs(td:GetScrolls()) do
            local data = split('=', v)
            local numData = {tonumber(data[1]), tonumber(data[2]), tonumber(data[3])}
            speedList[#speedList+1] = {
                Type  = sType.Scroll,
                Beat  = numData[1],
                Time  = td:GetElapsedTimeFromBeat(numData[1]),
                Value = numData[2],
            }
        end
        -- Timeでソートすると同位置が順不同になるのでBeatでソート
        table.sort(assistList, function(a, b)
            return string.format('%08d-%d', a.Beat*1000, a.Type) < string.format('%08d-%d', b.Beat*1000, b.Type)
        end)
        table.sort(speedList, function(a, b)
            return string.format('%08d-%d', a.Beat*1000, a.Type) < string.format('%08d-%d', b.Beat*1000, b.Type)
        end)
    end,
    AssistActor(),
})