return Def.ActorFrame({
    LoadActor('bg'),
    LoadActor('cover'),
    -- デモ画面でのジャケット表示背景
    LoadActor(W:Object('boxshadow'), 'DemoJacketBg', {
        Center = color('0.1, 0.14, 0.15, 0.9'),
        Length = 10,
        Color  = color('0.1, 0.1, 0.1, 0.5'),
    })..{
        InitCommand = function(self)
            self:playcommand('UpdateBoxShadow', {
                Id     = 'DemoJacketBg',
                Width  = 260,
                Height = 260,
            })
        end,
        OnCommand = function(self)
            self:visible(GAMESTATE:IsDemonstration())
            if not GAMESTATE:IsDemonstration() then return end
            self:x(SCREEN_WIDTH - 160)
            self:y(SCREEN_CENTER_Y+35)
            self:addx(200)
            self:diffusealpha(0)
            self:sleep(math.min(W_TIMER:GameJacketSleep(), 1.8))
            self:linear(0.4)
            self:addx(-200)
            self:diffusealpha(1)
        end,
    },
    Def.ActorFrame({
        OnCommand= function(self)
            self:Center()
            if not GAMESTATE:IsDemonstration() then
                self:sleep(W_TIMER:GameJacketSleep())
                self:bouncebegin(0.4)
                self:diffusealpha(0)
                self:zoom(2)
            else
                self:sleep(math.min(W_TIMER:GameJacketSleep(), 1.8))
                self:bouncebegin(0.4)
                --self:x(THEME:GetMetric('ScreenGameplay', 'PlayerP2OnePlayerOneSideX'))
                self:x(SCREEN_WIDTH - 160)
                self:y(SCREEN_CENTER_Y + 30)
                self:zoom(0.75)
            end
        end,
        -- ジャケット
        LoadActor('song jacket'),
    }),
    -- 曲名（ジャケットの上）
    Def.ActorFrame({
        OnCommand= function(self)
            self:Center()
        end,
        LoadActor('song title'),
    }),
})