local function OverActorNormal(name, beforeSleep, afterSleep, ...)
    local afterLinear = ...
    return LoadActor(THEME:GetPathG('ScreenGameplay/failed/failed', name))..{
        InitCommand = function(self)
            self:scaletocover(0, 0, 1280, 480)
            self:Center()
            self:diffusealpha(0)
            self:zoom(2)
        end,
        OnCommand = function(self)
            self:sleep(beforeSleep)
            self:linear(0.2)
            self:diffusealpha(1)
            self:zoom(1)
            self:sleep(afterSleep)
            self:linear(afterLinear or 0.5)
            self:diffusealpha(0)
        end,
    }
end

local function OverActorAdd(name, beforeSleep, isSpring)
    return LoadActor(THEME:GetPathG('ScreenGameplay/failed/failed', name))..{
        InitCommand = function(self)
            self:scaletocover(0, 0, 1280, 480)
            self:Center()
            self:diffusealpha(0)
            self:zoom(2)
            self:blend('BlendMode_Add')
        end,
        OnCommand = function(self)
            self:sleep(beforeSleep)
            if isSpring then
                self:spring(1.0)
                self:diffusealpha(0.5)
            else
                self:linear(0.2)
                self:diffusealpha(1)
            end
            self:zoom(1)
            self:linear(0.5)
            self:diffusealpha(0)
        end,
    }
end

return Def.ActorFrame({
    Def.Quad({
        InitCommand = function(self)
            self:FullScreen()
            self:diffuse(1, 1, 1, 0)
        end,
        OnCommand = function(self)
            self:sleep(0.5)
            self:linear(0.5)
            self:diffuse(1, 1, 1, 1)
            self:linear(1.5)
            self:diffuse(0, 0, 0, 1)
        end,
    }),
    OverActorNormal('over1', 0.4, 0.5),
    OverActorNormal('over2', 0.5, 0.4),
    OverActorNormal('over3', 0.6, 0.3),
    OverActorNormal('over4', 0.7, 0.2),
    OverActorAdd('over1', 0.1, true),
    OverActorAdd('over2', 0.2, true),
    OverActorAdd('over3', 0.3, true),
    OverActorAdd('over4', 0.4, true),
    OverActorNormal('over5', 0.8, 0.5, 1.5),
    OverActorAdd('over5', 0.8, false),
    LoadActor(THEME:GetPathG('ScreenGameplay/failed/failed', 'text'))..{
        InitCommand = function(self)
            self:scaletocover(0, 0, 1280, 480)
            self:Center()
            self:diffusealpha(0)
            self:zoom(2)
        end,
        OnCommand = function(self)
            self:sleep(0.5)
            self:linear(0.2)
            self:diffusealpha(1)
            self:zoom(1)
        end,
    },
    LoadActor(THEME:GetPathG('ScreenGameplay/failed/failed', 'text'))..{
        InitCommand = function(self)
            self:scaletocover(0, 0, 1280, 480)
            self:Center()
            self:diffusealpha(0)
            self:zoom(1)
            self:blend('BlendMode_Add')
        end,
        OnCommand = function(self)
            self:sleep(1.0)
            self:diffusealpha(1)
            self:linear(0.4)
            self:diffusealpha(0)
        end,
    },
    Def.Quad({
        InitCommand = function(self)
            self:FullScreen()
            self:diffuse(0, 0, 0, 0)
        end,
        OnCommand = function(self)
            self:sleep(2.5)
            self:linear(0.5)
            self:diffusealpha(1)
        end,
    }),
    LoadActor(THEME:GetPathS('ScreenGameplay', 'failed'))..{
        StartTransitioningCommand = function(self)
            self:sleep(0.5)
            self:play()
        end,
    },
})