local text = {
    {Timer = 7, BeginAnime = true,  Title = 0, Body = 'TextBegin'},
    {Timer = 4, BeginAnime = true,  Title = 1, Body = 'TextTap',},
    {Timer = 4, BeginAnime = false, Title = 1, Body = 'TextJump',},
    {Timer = 6, BeginAnime = true,  Title = 2, Body = 'TextHold',},
    {Timer = 6, BeginAnime = true,  Title = 3, Body = 'TextRoll',},
    {Timer = 5, BeginAnime = true,  Title = 4, Body = 'TextMine',},
    {Timer = 4, BeginAnime = true,  Title = 5, Body = 'TextLift',},
    {Timer = 4, BeginAnime = true,  Title = 6, Body = 'TextLife',},
    {Timer = 4, BeginAnime = false, Title = 6, Body = 'TextEnd',},
}
local current = 0

local fps = 1.0/60
local tmpDelta = 0

local function update(self, delta)
    tmpDelta = tmpDelta + delta
    if tmpDelta > fps then
        tmpDelta = tmpDelta - fps
        -- 毎フレーム発行
        MESSAGEMAN:Broadcast('ScreenUpdate', {
            Song     = song or nil,
            Beat     = GAMESTATE:GetSongBeat(),
            Sec      = GAMESTATE:GetSongPosition():GetMusicSeconds(),
            Gameplay = true,
        })
    end
end


return Def.ActorFrame({
    InitCommand = function(self)
        self:SetUpdateFunction(update)
    end,
    Def.Quad({
        OnCommand = function(self)
            self:zoomto(280, 0)
            self:diffuse(0, 0, 0, 0.66)
            self:fadetop(0.5)
            self:fadebottom(0.5)
            self:x(-SCREEN_CENTER_X+THEME:GetMetric('ScreenGameplay', 'PlayerP2OnePlayerOneSideX')-30)
            self:sleep(0.1)
            self:linear(0.25)
            self:zoomto(280, SCREEN_HEIGHT*2)
        end,
    }),
    -- ライフバーより上に表示されてしまうのでここでProxyで描画して対応
    Def.ActorProxy({
        OnCommand = function(self)
            self:SetTarget(SCREENMAN:GetTopScreen():GetChild('Player'))
            self:x(-SCREEN_CENTER_X+THEME:GetMetric('ScreenGameplay', 'PlayerP2OnePlayerOneSideX')-30)
            self:y(-SCREEN_CENTER_Y+15)
        end,
        OffCommand = function(self)
            self:sleep(0.25)
        end,
    }),
    Def.ActorFrame({
        FOV = 60,
        OffCommand = function(self)
            self:stoptweening()
            self:finishtweening()
        end,
        InitCommand = function(self)
            self:xy(-160, 120)
            self:rotationx(10)
            self:sleep(3.5)
            self:linear(0.5)
            self:rotationy(-155)
            self:rotationx(45)
            self:linear(36.25)
            self:addy(20)
            self:rotationy(-30)
            self:rotationx(20)
        end,
        LoadActor(W:Object('character'), {
            {{Name = 'Wait'},  7.5},
            {{Name = 'Begin'}, 0.5},
            {{Name = 'End'},   0.5},
            {{Name = 'Wait'},  3.0},
            {{Name = 'Jump'},  1.0},
            {{Name = 'Wait'},  3.0},
            {{Name = 'Begin'}, 3.5},
            {{Name = 'End'},   0.5},
            {{Name = 'Wait'},  2.0},
            {{Name = 'Begin'}, 0.5},
            {{Name = 'Roll'},  3.0},
            {{Name = 'End'},   0.5},
            {{Name = 'Wait'},  6.0},
            {{Name = 'Begin'}, 1.3},
            {{Name = 'End'},   0.7},
            {{Name = 'Begin'}, 1.3},
            {{Name = 'End'},   0.7},
            {{Name = 'Wait'}, 99.0},
        }),
        LoadActor(W:Object('panel'), 'howtoplay')..{
            InitCommand = function(self)
                self:y(12)
            end,
        },
    }),
    Def.ActorFrame({
        LoadActor(THEME:GetPathG('', 'ScreenGameplay/_parts/frame/life'), PLAYER_2)..{
            InitCommand = function(self)
                local x = THEME:GetMetric('ScreenGameplay', 'PlayerP2OnePlayerOneSideX')
                self:xy(-SCREEN_CENTER_X + x - 30, -SCREEN_CENTER_Y + 40)
            end,
        },
    }),
    Def.ActorFrame({
        InitCommand = function(self)
            self:xy(-160, -160)
        end,
        OnCommand = function(self)
            self:queuecommand('TextUpdate')
        end,
        TextUpdateCommand = function(self)
            current = current+1
            self:playcommand('TextUpdateChild', text[current])
            self:sleep(text[current].Timer)
            if current < #text then
                self:queuecommand('TextUpdate')
            end
        end,
        OffCommand = function(self)
            self:finishtweening()
        end,
        LoadActor('title')..{
            InitCommand = function(self)
                self:animate(false)
            end,
            TextUpdateChildCommand = function(self, params)
                self:setstate(params.Title)
                if params.BeginAnime then
                    self:diffusealpha(0)
                    self:zoomx(2)
                    self:linear(0.1)
                    self:diffusealpha(1)
                    self:zoomx(1)
                end
            end,
        },
        LoadFont('Common Small Normal')..{
            Text = '',
            InitCommand = function(self)
                self:diffuse(Color('White'))
                self:strokecolor(Color('Outline'))
                self:zoom(0.5)
                self:y(40)
                self:vertalign(top)
                self:vertspacing(5)
                self:wrapwidthpixels(300/0.5)
            end,
            TextUpdateChildCommand = function(self, params)
                self:cropright(1)
                self:settext(THEME:GetString('ScreenHowToPlay', params.Body))
                self:sleep(0.5)
                self:linear(0.25)
                self:cropright(0)
            end,
        },
    }),
    Def.Quad({
        InitCommand = function(self)
            self:diffuse(0, 0, 0, 1)
            self:FullScreen()
            self:xy(0, 0)
        end,
        OnCommand = function(self)
            self:linear(0.2)
            self:diffusealpha(0)
        end,
        OffCommand = function(self)
            self:linear(0.5)
            self:diffusealpha(1)
        end,
    }),
    LoadActor(W:Object('header'), 'How To Play'),
})
