local function InitActor(file, wait, sleep)
    return Def.ActorFrame({
        OnCommand = function(self)
            self:diffusealpha(0)
            self:sleep(wait)
            self:diffusealpha(1)
            self:sleep(sleep)
            self:linear(0.2)
            self:x(-100)
            self:diffusealpha(0)
        end,
        LoadActor(file, wait, sleep),
})
end

local function MainActors()
    local bgList = {
        {'waiei', color('#1188cc'), color('#00ffdd'), 2},
        {'sm',    color('#ffffff'), color('#ffffff'), 1},
        {'core',  color('#112233'), color('#112233'), 1},
        {'note1', color('#888844'), color('#bb8844'), 10},
        {'note2', color('#884444'), color('#442200'), 10},
    }

    local actors = Def.ActorFrame({
        LoadActor('bg', bgList),
    })

    local w = 0.5
    for i=1, #bgList do
        actors[#actors+1] = InitActor(bgList[i][1], w, bgList[i][4]-0.2)
        w = w + bgList[i][4]
    end

    return actors
end

return Def.ActorFrame({
    MainActors(),
})