local name = Var('LoadingScreen')
local function PlayerActor(pn)
    return Def.ActorFrame({
        InitCommand = function(self)
            self:xy((pn == PLAYER_1) and SCREEN_LEFT + 40 or SCREEN_RIGHT - 40, 49)
        end,
        OnCommand = function(self)
            if name == 'ScreenPlayerOptions' then
                self:addx((pn == PLAYER_1) and -100 or 100)
                self:linear(0.2)
                self:diffusealpha(1)
                self:addx((pn == PLAYER_1) and 100 or -100)
            end
        end,
        OffCommand = function(self)
            if name ~= 'ScreenPlayerOptions' then
                self:linear(0.2)
                self:diffusealpha(0)
                self:addx((pn == PLAYER_1) and -100 or 100)
            end
        end,
        LoadActor(W:Object('radius'), {
            Id     = 'StyleFill',
            Width  = 110,
            Height = 18,
            Radius = 18,
            Color  = BoostColor(W_PLAYER:Color(pn), 0.6),
        }):Actor(),
        LoadActor(W:Object('radius'), {
            Id     = 'StylePill',
            Fill   = false,
            Width  = 110,
            Height = 18,
            Radius = 18,
            Color  = color('#ffffff80'),
        
        }):Actor(),
        LoadFont('Common Normal')..{
            Text = 'PLAYER '..((pn == PLAYER_1) and 1 or 2),
            InitCommand = function(self)
                self:zoom(0.5)
            end,
        },
    })
end

local actors = Def.ActorFrame({})
for _,pn in pairs(PlayerNumber) do
    if W_PLAYER:IsEnabled(pn) then
        actors[#actors+1] = PlayerActor(pn)
    end
end
-- ハイスピード情報
actors[#actors+1] = LoadActor(W:Object('highspeed label'), 'Options')..{
    OnCommand = function(self)
        self:playcommand('Show', {Player = PLAYER_1, Wait = (name == 'ScreenPlayerOptions') and 0.2 or 0, Sleep = 0})
        self:playcommand('Show', {Player = PLAYER_2, Wait = (name == 'ScreenPlayerOptions') and 0.2 or 0, Sleep = 0})
    end,
    OffCommand = function(self)
        if name ~= 'ScreenPlayerOptions' then
            self:playcommand('Hide')
        end
    end,
}

return actors