local isPlayOption = ...
local name = Var('LoadingScreen')
local isMap = (name=='ScreenMapControllers')
local bgHeight = isMap and SCREEN_HEIGHT or 380

local function QuadActor(y, width, height, quadColor)
    return Def.Quad({
        OnCommand = function(self)
            self:y(y)
            self:zoomto(width, height)
            self:diffuse(quadColor)
            self:fadeleft(0.5)
            self:faderight(0.5)
        end,
    })
end

local function HeadActor(isMap, isPlayOption)
    if isPlayOption then
        return LoadActor(THEME:GetPathG('', 'ScreenOptionMaster/_parts/player'))
    end
    return LoadActor(THEME:GetPathG('', 'ScreenOptionMaster/_parts/logo'), isMap or false)
end

return Def.ActorFrame({
    Def.ActorFrame({
        InitCommand = function(self)
            self:Center()
        end,
        OnCommand = function(self)
            self:zoomx(0)
            self:linear(0.2)
            self:zoomx(1)
        end,
        OffCommand = function(self)
            self:linear(0.2)
            self:zoomx(0)
        end,
        QuadActor((isMap and 0 or 20), SCREEN_WIDTH*2, bgHeight, {0, 0, 0, 0.75}),
        Def.ActorFrame({
            InitCommand = function(self)
                self:visible(not isMap)
            end,
            QuadActor(-170, SCREEN_WIDTH*2, 1, {1, 1, 1, 0.75}),
            QuadActor(210, SCREEN_WIDTH*2, 1, {1, 1, 1, 0.75}),
            QuadActor(155, SCREEN_WIDTH*2, 1, {1, 1, 1, 0.5}),
        }),
    }),
    HeadActor(isMap, isPlayOption or false),
})
