-- タイトル横のバナー
local Banner = LoadActor(W:Object('banner'), {
    Song  = W:Song(),
    Size  = 230,
    Ratio = 230/130,
    Cache = 0.3,
    Rate  = 0.333333,
})

local bannerWidth = 4
local bannerHeight = 4

return Def.ActorFrame({
    OffCommand = function(self)
        setenv('WAIEI_BannerSize', Banner:Detail())
        self:sleep(0.1)
        self:bouncebegin(0.4)
        self:xy(0, SCREEN_CENTER_Y)
        self:sleep(0.4)
    end,
    -- 影
    LoadActor(W:Object('boxshadow'), 'BannerFrame', {
        Length = 20,
        Color  = {0, 0, 0, 0.4},
        Center = {0, 0, 0, 0.8},
    })..{
        UpdateBannerShadowCommand = function(self, params)
            bannerWidth = params.MaxWidth
            bannerHeight = params.RealHeight
            self:playcommand('UpdateBoxShadow', {
                Id         = 'BannerFrame',
                Width      = bannerWidth,
                Height     = bannerHeight,
            })
        end,
    },
    -- 情報の更新はWheelのRouletteに記述する
    Banner:Actor()..{
        UpdateMainBannerMessageCommand = function(self, params)
            params.Id = 'Main'
            self:playcommand('UpdateBanner', params)
        end,
        CallbackBannerCommand = function(self, params)
            self:GetParent():playcommand('UpdateBannerShadow', params)
        end,
    },
})