return Def.ActorFrame({
    InitCommand = function(self)
        self:xy(0, -SCREEN_CENTER_Y)
    end,
    Def.Quad({
        InitCommand = function(self)
            self:zoomto(SCREEN_CENTER_X-70, 150)
            self:horizalign(right)
            self:vertalign(top)
            self:xy(SCREEN_RIGHT-SCREEN_CENTER_X, 0)
            self:diffuse(0, 0, 0, 0.6)
        end,
        OffCommand = function(self)
            self:linear(0.2)
            self:zoomto(SCREEN_CENTER_X-70, SCREEN_HEIGHT)
            self:zoomto(SCREEN_WIDTH, SCREEN_HEIGHT)
            self:linear(0.2)
            self:diffuse(0.1, 0.1, 0.12, 1.0)
        end,
    }),
    -- バナー
    LoadActor('../banner')..{
        OnCommand = function(self)
            self:xy(-70, 75)
        end,
    },
    -- 境界線
    Def.Quad({
        InitCommand = function(self)
            self:zoomto(240, 1)
            self:horizalign(left)
            self:xy(70, 85)
            self:diffuse(1, 1, 1, 0.5)
            self:faderight(1)
        end,
        OffCommand = function(self)
            self:linear(0.2)
            self:diffusealpha(0)
        end,
    }),
    -- コース名
    LoadActor(W:Object('song title'), {
        Width = 220 + (SCREEN_WIDTH-660)/2,
    })..{
        OnCommand = function(self)
            self:xy(80, 115)
        end,
        OffCommand = function(self)
            self:linear(0.2)
            self:diffusealpha(0)
        end,
    },
    -- コース紹介
    LoadFont('Common Normal')..{
        Text = '',
        OnCommand = function(self)
            self:xy(80, 74)
            self:horizalign(left)
            self:vertalign(bottom)
            self:zoom(0.5)
            self:maxwidth(math.min(SCREEN_WIDTH/4, 200)/0.5)
            self:wrapwidthpixels(math.min(SCREEN_WIDTH/4, 200)/0.5)
            self:vertspacing(5)
            self:playcommand('CurrentCourseChanged')
        end,
        CurrentCourseChangedMessageCommand = function(self, params)
            local course = GAMESTATE:GetCurrentCourse()
            self:diffuse(1, 1, 1, 1)
            if course then
                if not course:IsAutogen() then
                    self:settext(course:GetDescription())
                elseif course:IsAutogen() then
                    self:settext(THEME:GetString('ScreenSelectCourse', 'AutoGen'))
                end
            else
                self:settext('')
            end
        end,
        OffCommand = function(self)
            self:linear(0.2)
            self:diffusealpha(0)
        end,
    },
    Def.ActorFrame({
        OffCommand = function(self)
            self:sleep(0.2)
            self:linear(0.2)
            self:addy(SCREEN_HEIGHT-150)
        end,
        -- 楽曲一覧
        LoadActor('song list')..{
            OnCommand = function(self)
                self:y(SCREEN_CENTER_Y + 100)
            end,
        },
        -- スコア
        LoadActor('score list', PLAYER_1)..{
            OnCommand = function(self)
                self:xy(THEME:GetMetric('ScreenSelectMusic', 'GrooveRadarXPositionOffset') * -1, SCREEN_CENTER_Y + 100)
            end,
        },
        LoadActor('score list', PLAYER_2)..{
            OnCommand = function(self)
                self:xy(THEME:GetMetric('ScreenSelectMusic', 'GrooveRadarXPositionOffset'), SCREEN_CENTER_Y + 100)
            end,
        },
    }),
})
