local width = 180 + math.min(40, (SCREEN_WIDTH-640)/4)

-- THEME:GetString だと大文字小文字を区別する上に取得できないと警告出すので事前に取得しておく
local list = {}
local wheelTexts = THEME:GetStringNamesInGroup('MusicWheel')
for i=1, #wheelTexts do
    list[string.lower(wheelTexts[i])] = wheelTexts[i]
end

return Def.ActorFrame({
    OnCommand = function(self)
        self:xy(0, -80)
    end,
    OffCommand = function(self)
        self:sleep(0.2)
        self:linear(0.2)
        self:addy(SCREEN_HEIGHT-150)
    end,
    LoadActor('frame')..{
        InitCommand = function(self)
            self:horizalign(left)
            self:x(SCREEN_CENTER_X - (width + 20))
        end,
    },
    -- グループ名
    LoadFont('Common Normal')..{
        Text = '';
        InitCommand = function(self)
            self:zoom(0.6)
            self:maxwidth((width-8)/0.6)
            self:horizalign(left)
            self:xy(SCREEN_CENTER_X - (width + 5), 0.5)
            self:diffuse(Color('Yellow'))
            self:strokecolor(Color('Outline'))
            --self:skewx(-0.2)
        end,
        ChangedSongMessageCommand = function(self, params)
            self:settext('')
            if params then
                if params.Song then
                    local group = params.Song:GetGroupName()
                    local groupColor = YA_GROUP:GroupColor(group) or Color('Yellow')
                    self:diffuse(BoostColor(groupColor, 0.75))
                    self:diffusebottomedge(BoostColor(groupColor, 1.5))
                    self:settext(YA_GROUP:GroupName(group))
                else
                    self:diffuse(BoostColor(Color('Yellow'), 0.75))
                    self:diffusebottomedge(BoostColor(Color('Yellow'), 1.5))
                    local sort = string.lower(ToEnumShortString(GAMESTATE:GetSortOrder())..'text')
                    local text = list[sort] and THEME:GetString('MusicWheel', list[sort]) or ''
                    self:settext((text ~= '') and text or (params.Name and YA_GROUP:GroupName(params.Name) or ''))
                end
            end
        end,
    },
})