return Def.ActorFrame({
    InitCommand = function(self)
        self:xy(0, -SCREEN_CENTER_Y)
    end,
    Def.Quad({
        InitCommand = function(self)
            self:zoomto(SCREEN_CENTER_X-70, 150)
            self:horizalign(right)
            self:vertalign(top)
            self:xy(SCREEN_RIGHT-SCREEN_CENTER_X, 0)
            self:diffuse(0, 0, 0, 0.6)
        end,
        OffCommand = function(self)
            self:linear(0.2)
            self:zoomto(SCREEN_CENTER_X-70, SCREEN_HEIGHT)
            self:zoomto(SCREEN_WIDTH, SCREEN_HEIGHT)
            self:linear(0.2)
            self:diffuse(0.1, 0.1, 0.12, 1.0)
        end,
    }),
    -- バナー
    LoadActor('../banner')..{
        OnCommand = function(self)
            self:xy(-70, 75)
        end,
    },
    -- CDTitle
    Def.Sprite({
        InitCommand = function(self)
            self:horizalign(left)
            self:vertalign(bottom)
        end,
        CurrentSongChangedMessageCommand = function(self, params)
            local song = GAMESTATE:GetCurrentSong()
            if song and song:HasCDTitle()then
                self:LoadBackground(song:GetCDTitlePath())
                self:scaletofit(-35, -20, 35, 20)
                self:xy(-70 - 130, 75 + 65)
                self:visible(true)
            else
                self:visible(false)
            end
        end,
        OffCommand = function(self)
            self:linear(0.2)
            self:diffusealpha(0)
        end,
    }),
    -- 境界線
    Def.Quad({
        InitCommand = function(self)
            self:zoomto(240, 1)
            self:horizalign(left)
            self:xy(70, 85)
            self:diffuse(1, 1, 1, 0.5)
            self:faderight(1)
        end,
        OffCommand = function(self)
            self:linear(0.2)
            self:diffusealpha(0)
        end,
    }),
    -- 曲名
    LoadActor(W:Object('song title'), {
        Width = 220 + (SCREEN_WIDTH-660)/2,
    })..{
        OnCommand = function(self)
            self:xy(80, 115)
        end,
        OffCommand = function(self)
            -- self:sleep(0.2)
            -- self:linear(0.2)
            -- self:y(SCREEN_CENTER_Y)
            self:linear(0.2)
            self:diffusealpha(0)
        end,
    },
    -- BPM
    LoadActor('bpm')..{
        OnCommand = function(self)
            self:xy(80, 74)
        end,
        OffCommand = function(self)
            self:linear(0.2)
            self:diffusealpha(0)
        end,
    },
})
