local bodyText = {
    {
        ja = [[
このテーマは開発版です。
バグと思われる現象を発見しましたら
開発チームに報告いただけると幸いです。
]],
        en = [[
This theme is a development version.
If you find any bugs, please report them to the development team.
]],
    },
    {
        ja = [[
WAIEI CitMinはシンプルながらも
デザインやアニメーションにこだわり、
そのうえ従来のWAIEIシリーズと比較すると
かなり軽快に動作をするように設計されています。
]],
        en = [[
WAIEI CitMin is designed to be simple, but with a lot of attention to animation, etc., and yet it is much more nimble than the previous WAIEI series.
]],
    },
    {
        ja = [[
イベントモードでは&Select;を押すことで
テーマ専用のオプションメニューを素早く呼び出すことができます。

これらのメニューはオプションの
WAIEI OPTIONSでも設定変更が可能です。
]],
        en = [[
In the event mode, you can quickly call up a theme-specific options menu by pressing &Select;.

These menus can also be set and changed in the optional WAIEI OPTIONS.
]],
    },
    {
        ja = [[
グループ情報の設定に新しくGroup.luaを採用。
複雑な条件を指定することができるようになりました。

従来のGroup.iniも利用可能です。
]],
        en = [[
Group.lua is newly adopted for setting group information.
It is now possible to specify complex conditions.

Conventional Group.ini can also be used.
]],
    },
    {
        ja = [[
さらに機能を追加した正式版は近日公開予定です。

それでは、WAIEI CitMinをお楽しみください。
]],
        en = [[
The full version will be available soon.

So, enjoy WAIEI CitMin.
]],
    },
}

local lang = THEME:GetCurLanguage()
return Def.ActorFrame({
    Def.Sprite({
        InitCommand = function(self)
            self:LoadBackground(THEME:GetPathG('', 'ScreenSetup/feature/beta1/1'))
            self:scaletofit(-SCREEN_CENTER_X, -100, SCREEN_CENTER_X, 100)
            self:y(-50)
        end,
        ChangedMessageCommand = function(self, params)
            self:stoptweening()
            self:diffusealpha(0)
            self:LoadBackground(THEME:GetPathG('', 'ScreenSetup/feature/beta1/'..params.Index))
            self:scaletofit(-SCREEN_CENTER_X, -100, SCREEN_CENTER_X, 100)
            self:y(-50)
            self:linear(0.2)
            self:diffusealpha(1)
        end,
    }),
    LoadFont('Common Normal')..{
        Text = bodyText[1][lang] or bodyText[1].en or '',
        InitCommand = function(self)
            self:y(130)
            self:zoom(0.7)
            self:vertspacing(10)
            self:wrapwidthpixels(600/0.7)
        end,
        ChangedMessageCommand = function(self, params)
            self:stoptweening()
            self:diffusealpha(0)
            self:settext(bodyText[params.Index][lang] or bodyText[params.Index].en or '')
            self:linear(0.2)
            self:diffusealpha(1)
        end,
    }
})