local strOn, strOff = THEME:GetString('OptionNames', 'On'), THEME:GetString('OptionNames', 'Off')
W_JUDGMENT:Set(W_OPTION:ReadPref('JudgmentMode'))

return {
    Menu = {
        'UnJoin',
        'ScoreMode',
        'GradeType',
        'JacketWheel',
        'HighScoreType',
        'JudgmentMode',
        'DifficultyLabel',
        'DifficultyColor',
        'ContinueCombo',
        'ComboColor',
        'ComboAlways1',
        'BreakComboMineHit',
        'BreakComboHoldLetGo',
        'RollCombo',
        'JudgmentsUnderField',
        'ComboUnderField',
        'CourseBannerStrictCheck',
        'ExecBrowser',
        'StartMusicTiming',
        'FrameColor',
        'FrameLight',
        -- 'FrameOverlay',
        'DefaultMeterType',
        'DefaultLyricType',
        'Save',
    },
    OptionList = {
        UnJoin = {
            Type = 'None'
        },
        ContinueCombo = {
            Type    = 'Machine',
            Default = 4,
            List    = {'TapNoteScore_W1', 'TapNoteScore_W2', 'TapNoteScore_W3', 'TapNoteScore_W4'},
            Display = {
                string.upper(W_JUDGMENT:Name('TapNoteScore_W1')),
                string.upper(W_JUDGMENT:Name('TapNoteScore_W2')),
                string.upper(W_JUDGMENT:Name('TapNoteScore_W3')),
                string.upper(W_JUDGMENT:Name('TapNoteScore_W4')),
            },
        },
        ComboColor = {
            Type    = 'Machine',
            Default = 2,
            List    = {'StepMania', 'DDR X'},
            Display = {'StepMania', 'DDR X'},
        },
        BreakComboMineHit = {
            Type    = 'Machine',
            Default = 2,
            List    = {false, true},
            Display = {strOff, strOn},
        },
        BreakComboHoldLetGo = {
            Type    = 'Machine',
            Default = 2,
            List    = {false, true},
            Display = {strOff, strOn},
        },
        RollCombo = {
            Type    = 'Machine',
            Default = 1,
            List    = {false, true},
            Display = {strOff, strOn},
        },
        JudgmentsUnderField = {
            Type    = 'Machine',
            Default = 1,
            List    = {false, true},
            Display = {strOff, strOn},
        },
        ComboUnderField = {
            Type    = 'Machine',
            Default = 2,
            List    = {false, true},
            Display = {strOff, strOn},
        },
        CourseBannerStrictCheck = {
            Type    = 'Machine',
            Default = 2,
            List    = {false, true},
            Display = {strOff, strOn},
        },
        ExecBrowser = {
            Type    = 'Machine',
            Default = 1,
            List    = {false, true},
            Display = {strOff, strOn},
        },
        StartMusicTiming = {
            Type    = 'Machine',
            Default = 1,
            List    = {'Quickly', 'Slowly'},
            Display = {'Quickly', 'Slowly'},
        },
        FrameColor = {
            Type    = 'Machine',
            Default = 2,
            List    = {'0, 0, 0, 0', '0, 0, 0, 0.35', '0, 0, 0, 0.65', '0, 0, 0, 0.95'},
            Display = {'Transparent', 'Default', 'Dark', 'Black'},
        },
        FrameLight = {
            Type    = 'Machine',
            Default = 2,
            List    = {'Never', 'Auto', 'Always'},
            Display = {'Never', 'Auto', 'Always'},
        },
        -- FrameOverlay = {
        --     Type    = 'Machine',
        --     Default = 2,
        --     List    = {'0', '200'},
        --     Display = {'SM Default', 'TopLayer'},
        -- },
        ScoreMode = {
            Type    = 'Machine',
            Default = 1,
            List    = {'A', 'SN2', 'Classic', 'Hybrid'},
            Display = {'DDR A', 'SuperNOVA2', 'StepMania 3.9', 'Hybrid'},
        },
        DifficultyLabel = {
            Type    = 'Machine',
            Default = 1,
            List    = {'DDR', 'CLASSIC', 'SM'},
            Display = {'DDR', 'Classic', 'StepMania'},
        },
        DifficultyColor = {
            Type    = 'Machine',
            Default = 1,
            List    = {'DDR', 'SM'},
            Display = {'DDR', 'StepMania'},
        },
        HighScoreType = {
            Type    = 'Machine',
            Default = 2,
            List    = {false, true},
            Display = {'Normal Score', 'EXScore'},
        },
        JudgmentMode = {
            Type    = 'Machine',
            Default = 1,
            List    = {'DDR', 'SuperNOVA', 'StepMania'},
            Display = {'DDR', 'SuperNOVA', 'StepMania'},
        },
        DefaultMeterType = {
            Type    = 'Machine',
            Default = 1,
            List    = {'DDR', 'DDR X', 'ITG'},
            Display = {'DDR', 'DDR X', 'ITG'},
        },
        DefaultLyricType = {
            Type    = 'Machine',
            Default = 2,
            List    = {'Old', 'Default', 'LeftAndRight', 'VerticalFill', 'CenterRotation', 'BottomSide'},
            Display = {'StepMania 3.9', 'Default', 'Left And Right', 'Vertical Fill', 'Center Rotation', 'Bottom Side'},
        },
        GradeType = {
            Type    = 'Machine',
            Default = 1,
            List    = {'StepMania', 'DDR A'},
            Display = {'StepMania', 'DDR A'},
        },
        JacketWheel = {
            Type    = 'Machine',
            Default = 1,
            List    = {false, true},
            Display = {'Banner', 'Jacket'},
        },
        ComboAlways1 = {
            Type    = 'Machine',
            Default = 1,
            List    = {false, true},
            Display = {strOff, strOn},
        },
        Save = {
            Type = 'None'
        },
    },
}
