-- 画面切り替え

-- Init
local function GetInit(self, value)
    if value == 'After' then
        -- 放置
        return 'ScreenLogo'
    end
end

-- タイトル
local function GetTitle(self, value)
    if value == 'Start' then
        local ymd = string.format('%04d%02d%02d', Year(), MonthOfYear()+1, DayOfMonth())
        local expired = ''..string.char(0x32,0x30,0x32,0x35,0x30,0x31,0x30,0x31)
        if tonumber(ymd) >= tonumber(expired) then return 'ScreenExpired' end
        if PREFSMAN:GetPreference('ShowCaution') then
            return 'ScreenCaution'
        else
            return W_BRANCHE:Profile('Start')
        end
    end
end

-- PROFILE
local function GetProfile(self, value)
    if value == 'Start' then
        if SONGMAN:GetNumSongs() == 0 and SONGMAN:GetNumAdditionalSongs() == 0 then
            return 'ScreenHowToInstallSongs'
        end
        -- プロファイルの数関係なく選択画面を出す
        return "ScreenSelectProfile"
    elseif value == 'Finish' then
        if ( THEME:GetMetric('Common', 'AutoSetStyle') == true ) then
            return IsNetConnected() and 'ScreenSelectStyle' or 'ScreenSelectPlayMode'
        else
            return 'ScreenSelectStyle'
        end
    end
end

-- オプション
local function GetOption(self, value)
    local topScreen = SCREENMAN:GetTopScreen()
    if value == 'Player' then
        local pm = GAMESTATE:GetPlayMode()
        local restricted = { 'PlayMode_Rave',}
        local optionsScreen = 'ScreenPlayerOptions'
        for i = 1, #restricted do
            if restricted[i] == pm then
                optionsScreen = 'ScreenPlayerOptionsRestricted'
            end
        end
        if topScreen.GetGoToOptions and topScreen:GetGoToOptions() or (getenv('WAIEI_CallOptions') or false)
            and GAMESTATE:GetPlayMode() ~= 'PlayMode_Oni' then
            setenv('WAIEI_CallOptions', false)
            return optionsScreen
        else
            return 'ScreenStageInformation'
        end
    elseif value == 'Song' then
        -- if GAMESTATE:GetPlayMode() ~= 'PlayMode_Oni'
        --     and not GAMESTATE:IsAnExtraStage() then
        --     --and not IsDrill() then
        --     return 'ScreenSongOptions'
        -- else
        --     return 'ScreenStageInformation'
        -- end
        if topScreen.GetGoToOptions and topScreen:GetGoToOptions() or (getenv('WAIEI_CallOptions') or false)
            --and not IsDrill()
            and GAMESTATE:GetPlayMode() ~= 'PlayMode_Oni' then
            setenv('WAIEI_CallOptions', false)
            return "ScreenSongOptions"
        else
            return "ScreenStageInformation"
        end
    end
end

return {
    Init    = GetInit,
    Title   = GetTitle,
    Profile = GetProfile,
    Option  = GetOption,
}

--[[
Branches.lua

Copyright (c) 2021 A.C

This software is released under the MIT License.
https://opensource.org/licenses/mit-license.php
--]]
