local color = {
    TapNoteScore_W1    = color("#bfeaff"),
    TapNoteScore_W2    = color("#fff568"),
    TapNoteScore_W3    = color("#60e040"),
    TapNoteScore_W4    = color("#34bfff"),
    TapNoteScore_W5    = color("#e44dff"),
    TapNoteScore_Miss  = color("#ff4c4c"),
    HoldNoteScore_Held = color("#FFFFFF"),
}

local judgment = {
    StepMania = {
        TapNoteScore_W1 = 'Flawless',
        TapNoteScore_W2 = 'Perfect',
        TapNoteScore_W3 = 'Great',
        TapNoteScore_W4 = 'Good',
        TapNoteScore_W5 = 'Bad',
    },
    DDR = {
        TapNoteScore_W1 = 'Marvelous',
        TapNoteScore_W2 = 'Perfect',
        TapNoteScore_W3 = 'Great',
        TapNoteScore_W4 = 'Good',
        TapNoteScore_W5 = 'Boo',
    },
    SuperNOVA = {
        TapNoteScore_W1   = 'Marvelous',
        TapNoteScore_W2   = 'Perfect',
        TapNoteScore_W3   = 'Great',
        TapNoteScore_W4   = 'Good',
        TapNoteScore_W5   = 'Almost',
        TapNoteScore_Miss = 'Boo',
    },
}

local name = {}

-- 判定一覧を取得
local function GetList(self)
    return name or {}
end

-- 色を取得
local function GetColor(self, key)
    return color[key] or Color('White')
end

-- 判定名を取得
local function GetName(self, key)
    if #name == 0 then
        W_JUDGMENT:Set(W_OPTION:ReadPref('JudgmentMode'))
    end
    return name[key] or ''
end

-- 判定名を一括設定
local function SetNameList(self, ...)
    local mode = ...
    mode = mode or 'StepMania'
    name = {
        TapNoteScore_W1    = judgment[mode].TapNoteScore_W1    or 'W1',
        TapNoteScore_W2    = judgment[mode].TapNoteScore_W2    or 'W2',
        TapNoteScore_W3    = judgment[mode].TapNoteScore_W3    or 'W3',
        TapNoteScore_W4    = judgment[mode].TapNoteScore_W4    or 'W4',
        TapNoteScore_W5    = judgment[mode].TapNoteScore_W5    or 'W5',
        TapNoteScore_Miss  = judgment[mode].TapNoteScore_Miss  or 'Miss',
        HoldNoteScore_Held = judgment[mode].HoldNoteScore_Held or 'O.K.',
    }
end

return {
    Color = GetColor,
    Name  = GetName,
    List  = GetList,
    Set   = SetNameList,
}

--[[
Judgment.lua

Copyright (c) 2021 A.C

This software is released under the MIT License.
https://opensource.org/licenses/mit-license.php
--]]
